<?php

/*
	WPB Woocommerce Product Slider pro 
	Theme Customizer settings
	By WPBean
	Since V 3.04
	
*/


if ( ! defined( 'ABSPATH' ) ) exit; // Exit if accessed directly 


/* Settings API class */

require_once dirname( __FILE__ ) . '/class.settings-api.php';


/**
 * WPS Theme Customizer settings
 */

if ( !class_exists('wpb_wps_theme_customizer' ) ):
class wpb_wps_theme_customizer {
    private $settings_api;
    function __construct() {
        $this->settings_api = new WPB_WPS_WeDevs_Settings_API;
        add_action( 'admin_init', array($this, 'admin_init') );
        add_action( 'admin_menu', array($this, 'admin_menu') );
    }
    function admin_init() {
        //set the settings
        $this->settings_api->set_sections( $this->get_settings_sections() );
        $this->settings_api->set_fields( $this->get_settings_fields() );
        //initialize settings
        $this->settings_api->admin_init();
    }
    function admin_menu() {
        add_submenu_page( 
            'wpb_woo_product_slider', 
            __( 'Theme Customizer', 'wpb-woocommerce-product-slider' ),
            __( 'Theme Customizer', 'wpb-woocommerce-product-slider' ),
            'delete_posts',
            'wps-theme-customizer-settings',
            array($this, 'plugin_page')
        );
    }
    function get_settings_sections() {
        $sections = array(
            array(
                'id' 	=> 'ben_box',
                'title' => __( 'Ben Box', 'wpb-woocommerce-product-slider' )
            ),
            array(
                'id' 	=> 'hover',
                'title' => __( 'Hover', 'wpb-woocommerce-product-slider' )
            ),
            array(
                'id' 	=> 'fashion',
                'title' => __( 'Fashion', 'wpb-woocommerce-product-slider' )
            ),
            array(
                'id' 	=> 'black',
                'title' => __( 'Black', 'wpb-woocommerce-product-slider' )
            ),
            array(
                'id' 	=> 'jupiter',
                'title' => __( 'Jupiter', 'wpb-woocommerce-product-slider' )
            ),
            array(
                'id' 	=> 'mars',
                'title' => __( 'Mars', 'wpb-woocommerce-product-slider' )
            ),
        );
        return $sections;
    }
    /**
     * Returns all the settings fields
     *
     * @return array settings fields
     */
    function get_settings_fields() {
        $settings_fields = array(
            'ben_box' => array(
            	array(
                    'name'      => 'wpb_item_border_color',
                    'label'     => __( 'Product border color', 'wpb-woocommerce-product-slider' ),
                    'desc'      => __( 'Product item border color.', 'wpb-woocommerce-product-slider' ),
                    'type'      => 'color',
                    'default'   => '#ccc'
                ),
            	array(
                    'name'      => 'wpb_item_border_color_hover',
                    'label'     => __( 'Product hover border color', 'wpb-woocommerce-product-slider' ),
                    'desc'      => __( 'Product item on hover border color.', 'wpb-woocommerce-product-slider' ),
                    'type'      => 'color',
                    'default'   => '#f65b47'
                ),
                array(
                    'name'      => 'wpb_title_color',
                    'label'     => __( 'Title color', 'wpb-woocommerce-product-slider' ),
                    'type'      => 'color',
                    'default'   => '#111'
                ),
                array(
                    'name'      => 'wpb_title_color_hover',
                    'label'     => __( 'Title color on hover', 'wpb-woocommerce-product-slider' ),
                    'type'      => 'color',
                    'default'	=> '#f65b47',
                ),
                array(
                    'name'      => 'wpb_price_color',
                    'label'     => __( 'Price color', 'wpb-woocommerce-product-slider' ),
                    'type'      => 'color',
                    'default'   => '#f65b47'
                ),
                array(
                    'name'      => 'wpb_cart_btn_color',
                    'label'     => __( 'Cart button color', 'wpb-woocommerce-product-slider' ),
                    'type'      => 'color',
                    'default'   => '#b3abab'
                ),
                array(
                    'name'      => 'wpb_cart_btn_color_hover',
                    'label'     => __( 'Cart button hover color', 'wpb-woocommerce-product-slider' ),
                    'type'      => 'color',
                    'default'   => '#f65b47'
                ),
                array(
                    'name'      => 'wpb_cart_btn_border',
                    'label'     => __( 'Cart button border color', 'wpb-woocommerce-product-slider' ),
                    'type'      => 'color',
                    'default'   => '#b3abab'
                ),
                array(
                    'name'      => 'wpb_cart_btn_border_hover',
                    'label'     => __( 'Cart button hover border color', 'wpb-woocommerce-product-slider' ),
                    'type'      => 'color',
                    'default'   => '#f65b47'
                ),
                array(
                    'name'      => 'wpb_cart_btn_bg',
                    'label'     => __( 'Cart button background color', 'wpb-woocommerce-product-slider' ),
                    'type'      => 'color',
                ),
                array(
                    'name'      => 'wpb_cart_btn_bg_hover',
                    'label'     => __( 'Cart button hover background color', 'wpb-woocommerce-product-slider' ),
                    'type'      => 'color',
                ),
                array(
                    'name'      => 'wpb_add_btn_color',
                    'label'     => __( 'QuickView, compare, wishlist icons color', 'wpb-woocommerce-product-slider' ),
                    'type'      => 'color',
                ),
                array(
                    'name'      => 'wpb_onsale_bg',
                    'label'     => __( 'On sale background', 'wpb-woocommerce-product-slider' ),
                    'type'      => 'color',
                    'default'   => '#f65b47'
                ),
            ),
            'hover' => array(
            	array(
                    'name'      => 'wpb_overlay_color',
                    'label'     => __( 'On hover overlay color', 'wpb-woocommerce-product-slider' ),
                    'type'      => 'color',
                    'default'   => 'rgba(0,0,0,0.5)'
                ),
                array(
                    'name'      => 'wpb_title_color',
                    'label'     => __( 'Title color', 'wpb-woocommerce-product-slider' ),
                    'type'      => 'color',
                    'default'   => '#fff'
                ),
                array(
                    'name'      => 'wpb_title_color_hover',
                    'label'     => __( 'Title color on hover', 'wpb-woocommerce-product-slider' ),
                    'type'      => 'color',
                    'default'	=> '#f65b47',
                ),
                array(
                    'name'      => 'wpb_price_color',
                    'label'     => __( 'Price color', 'wpb-woocommerce-product-slider' ),
                    'type'      => 'color',
                    'default'   => '#f65b47'
                ),
                array(
                    'name'      => 'wpb_cart_btn_color',
                    'label'     => __( 'Cart button color', 'wpb-woocommerce-product-slider' ),
                    'type'      => 'color',
                    'default'   => '#fff'
                ),
                array(
                    'name'      => 'wpb_cart_btn_color_hover',
                    'label'     => __( 'Cart button hover color', 'wpb-woocommerce-product-slider' ),
                    'type'      => 'color',
                    'default'   => '#f65b47'
                ),
                array(
                    'name'      => 'wpb_cart_btn_border',
                    'label'     => __( 'Cart button border color', 'wpb-woocommerce-product-slider' ),
                    'type'      => 'color',
                    'default'   => '#fff'
                ),
                array(
                    'name'      => 'wpb_cart_btn_border_hover',
                    'label'     => __( 'Cart button hover border color', 'wpb-woocommerce-product-slider' ),
                    'type'      => 'color',
                    'default'   => '#f65b47'
                ),
                array(
                    'name'      => 'wpb_cart_btn_bg',
                    'label'     => __( 'Cart button background color', 'wpb-woocommerce-product-slider' ),
                    'type'      => 'color',
                ),
                array(
                    'name'      => 'wpb_cart_btn_bg_hover',
                    'label'     => __( 'Cart button hover background color', 'wpb-woocommerce-product-slider' ),
                    'type'      => 'color',
                ),
                array(
                    'name'      => 'wpb_onsale_bg',
                    'label'     => __( 'On sale background', 'wpb-woocommerce-product-slider' ),
                    'type'      => 'color',
                    'default'   => '#f65b47'
                ),
            ),
            'fashion' => array(
            	array(
                    'name'      => 'wpb_title_color',
                    'label'     => __( 'Title color', 'wpb-woocommerce-product-slider' ),
                    'type'      => 'color',
                    'default'   => '#9f9f9f'
                ),
                array(
                    'name'      => 'wpb_title_color_hover',
                    'label'     => __( 'Title color on hover', 'wpb-woocommerce-product-slider' ),
                    'type'      => 'color',
                ),
                array(
                    'name'      => 'wpb_price_color',
                    'label'     => __( 'Price color', 'wpb-woocommerce-product-slider' ),
                    'type'      => 'color',
                    'default'   => '#3e7cb4'
                ),
            	array(
                    'name'      => 'wpb_cart_btn_bg',
                    'label'     => __( 'Cart button background color', 'wpb-woocommerce-product-slider' ),
                    'type'      => 'color',
                    'default'   => '#3e7cb4'
                ),
                array(
                    'name'      => 'wpb_cart_btn_bg_hover',
                    'label'     => __( 'Cart button hover background color', 'wpb-woocommerce-product-slider' ),
                    'type'      => 'color',
                    'default'   => '#444'
                ),
                array(
                    'name'      => 'wpb_cart_btn_color',
                    'label'     => __( 'Cart button color', 'wpb-woocommerce-product-slider' ),
                    'type'      => 'color',
                    'default'   => '#fff'
                ),
                array(
                    'name'      => 'wpb_cart_btn_color_hover',
                    'label'     => __( 'Cart button hover color', 'wpb-woocommerce-product-slider' ),
                    'type'      => 'color',
                    'default'   => '#fff'
                ),
                array(
                    'name'      => 'wpb_add_btn_color',
                    'label'     => __( 'QuickView, compare, wishlist icons color', 'wpb-woocommerce-product-slider' ),
                    'type'      => 'color',
                ),
                array(
                    'name'      => 'wpb_onsale_bg',
                    'label'     => __( 'On sale background', 'wpb-woocommerce-product-slider' ),
                    'type'      => 'color',
                    'default'   => '#3e7cb4'
                ),
            ),
            'black' => array(
                array(
                    'name'      => 'wpb_title_color',
                    'label'     => __( 'Title color', 'wpb-woocommerce-product-slider' ),
                    'type'      => 'color',
                    'default'   => '#252525'
                ),
                array(
                    'name'      => 'wpb_title_color_hover',
                    'label'     => __( 'Title color on hover', 'wpb-woocommerce-product-slider' ),
                    'type'      => 'color',
                    'default'   => '#EA2C58'
                ),
                array(
                    'name'      => 'wpb_rating',
                    'label'     => __( 'Rating color', 'wpb-woocommerce-product-slider' ),
                    'type'      => 'color',
                    'default'   => '#EA2C58'
                ),
                array(
                    'name'      => 'wpb_price_color',
                    'label'     => __( 'Price color', 'wpb-woocommerce-product-slider' ),
                    'type'      => 'color',
                    'default'   => '#4a4a4a'
                ),
            	array(
                    'name'      => 'wpb_cart_btn_bg',
                    'label'     => __( 'Cart button background color', 'wpb-woocommerce-product-slider' ),
                    'type'      => 'color',
                    'default'   => '#252525'
                ),
                array(
                    'name'      => 'wpb_cart_btn_bg_hover',
                    'label'     => __( 'Cart button hover background color', 'wpb-woocommerce-product-slider' ),
                    'type'      => 'color',
                    'default'   => '#EA2C58'
                ),
                array(
                    'name'      => 'wpb_cart_btn_color',
                    'label'     => __( 'Cart button color', 'wpb-woocommerce-product-slider' ),
                    'type'      => 'color',
                    'default'   => '#fff'
                ),
                array(
                    'name'      => 'wpb_cart_btn_color_hover',
                    'label'     => __( 'Cart button hover color', 'wpb-woocommerce-product-slider' ),
                    'type'      => 'color',
                    'default'   => '#fff'
                ),
                array(
                    'name'      => 'wpb_wishlist_btn_bg',
                    'label'     => __( 'Wishlist button background', 'wpb-woocommerce-product-slider' ),
                    'type'      => 'color',
                    'default'   => '#EA2C58'
                ),
                array(
                    'name'      => 'wpb_wishlist_btn_bg_hover',
                    'label'     => __( 'Wishlist button hover background', 'wpb-woocommerce-product-slider' ),
                    'type'      => 'color',
                    'default'   => '#666666'
                ),
                array(
                    'name'      => 'wpb_wishlist_btn_color',
                    'label'     => __( 'Wishlist button color', 'wpb-woocommerce-product-slider' ),
                    'type'      => 'color',
                    'default'   => '#fff'
                ),
                array(
                    'name'      => 'wpb_wishlist_btn_color_hover',
                    'label'     => __( 'Wishlist button hover color', 'wpb-woocommerce-product-slider' ),
                    'type'      => 'color',
                    'default'   => '#fff'
                ),
                array(
                    'name'      => 'wpb_onsale_bg',
                    'label'     => __( 'On sale background', 'wpb-woocommerce-product-slider' ),
                    'type'      => 'color',
                    'default'   => '#EA2C58'
                ),
            ),
            'jupiter' => array(
                array(
                    'name'      => 'wpb_title_color',
                    'label'     => __( 'Title color', 'wpb-woocommerce-product-slider' ),
                    'type'      => 'color',
                    'default'   => '#252525'
                ),
                array(
                    'name'      => 'wpb_title_color_hover',
                    'label'     => __( 'Title color on hover', 'wpb-woocommerce-product-slider' ),
                    'type'      => 'color',
                ),
                array(
                    'name'      => 'wpb_rating',
                    'label'     => __( 'Rating color', 'wpb-woocommerce-product-slider' ),
                    'type'      => 'color',
                    'default'   => '#EA2C58'
                ),
                array(
                    'name'      => 'wpb_price_color',
                    'label'     => __( 'Price color', 'wpb-woocommerce-product-slider' ),
                    'type'      => 'color',
                    'default'   => '#4a4a4a'
                ),
                array(
                    'name'      => 'wpb_add_btn_bg',
                    'label'     => __( 'Cart, quick view & wishlist button background', 'wpb-woocommerce-product-slider' ),
                    'type'      => 'color',
                    'default'   => '#333'
                ),
                array(
                    'name'      => 'wpb_add_btn_bg_hover',
                    'label'     => __( 'Cart, quick view & wishlist button hover background', 'wpb-woocommerce-product-slider' ),
                    'type'      => 'color',
                    'default'   => '#666'
                ),
                array(
                    'name'      => 'wpb_add_btn_color',
                    'label'     => __( 'Cart, quick view & wishlist button color', 'wpb-woocommerce-product-slider' ),
                    'type'      => 'color',
                    'default'   => '#fff'
                ),
                array(
                    'name'      => 'wpb_add_btn_color_hover',
                    'label'     => __( 'Cart, quick view & wishlist button hover color', 'wpb-woocommerce-product-slider' ),
                    'type'      => 'color',
                    'default'   => '#fff'
                ),
                array(
                    'name'      => 'wpb_onsale_bg',
                    'label'     => __( 'On sale background', 'wpb-woocommerce-product-slider' ),
                    'type'      => 'color',
                    'default'   => '#666'
                )
            ),
            'mars' => array(
            	array(
                    'name'      => 'wpb_overlay_color',
                    'label'     => __( 'On hover overlay color', 'wpb-woocommerce-product-slider' ),
                    'type'      => 'color',
                    'default'   => 'rgba(51,51,51,.3)'
                ),
            	array(
                    'name'      => 'wpb_cart_btn_bg',
                    'label'     => __( 'Cart button background color', 'wpb-woocommerce-product-slider' ),
                    'type'      => 'color',
                    'default'   => '#fff'
                ),
                array(
                    'name'      => 'wpb_cart_btn_bg_hover',
                    'label'     => __( 'Cart button hover background color', 'wpb-woocommerce-product-slider' ),
                    'type'      => 'color',
                    'default'   => '#333'
                ),
                array(
                    'name'      => 'wpb_cart_btn_color',
                    'label'     => __( 'Cart button color', 'wpb-woocommerce-product-slider' ),
                    'type'      => 'color',
                    'default'   => '#333'
                ),
                array(
                    'name'      => 'wpb_cart_btn_color_hover',
                    'label'     => __( 'Cart button hover color', 'wpb-woocommerce-product-slider' ),
                    'type'      => 'color',
                    'default'   => '#fff'
                ),
                array(
                    'name'      => 'wpb_add_btn_bg',
                    'label'     => __( 'Quick view & wishlist button background', 'wpb-woocommerce-product-slider' ),
                    'type'      => 'color',
                    'default'   => '#333'
                ),
                array(
                    'name'      => 'wpb_add_btn_bg_hover',
                    'label'     => __( 'Quick view & wishlist button hover background', 'wpb-woocommerce-product-slider' ),
                    'type'      => 'color',
                    'default'   => '#666'
                ),
                array(
                    'name'      => 'wpb_add_btn_color',
                    'label'     => __( 'Quick view & wishlist button color', 'wpb-woocommerce-product-slider' ),
                    'type'      => 'color',
                    'default'   => '#fff'
                ),
                array(
                    'name'      => 'wpb_add_btn_color_hover',
                    'label'     => __( 'Quick view & wishlist button hover color', 'wpb-woocommerce-product-slider' ),
                    'type'      => 'color',
                    'default'   => '#fff'
                ),
                array(
                    'name'      => 'wpb_onsale_bg',
                    'label'     => __( 'On sale background', 'wpb-woocommerce-product-slider' ),
                    'type'      => 'color',
                    'default'   => '#333'
                )
            )
        );
        return $settings_fields;
    }
    function plugin_page() {
        echo '<div class="wrap">';
        $this->settings_api->show_navigation();
        $this->settings_api->show_forms();
        echo '</div>';
    }
    /**
     * Get all the pages
     *
     * @return array page names with key value pairs
     */
    function get_pages() {
        $pages = get_pages();
        $pages_options = array();
        if ( $pages ) {
            foreach ($pages as $page) {
                $pages_options[$page->ID] = $page->post_title;
            }
        }
        return $pages_options;
    }
}
endif;

$wpb_wps_theme_customizer = new wpb_wps_theme_customizer();