<?php

/*
	WPB Woocommerce Product Slider pro 
	By WPBean
	
*/

if ( ! defined( 'ABSPATH' ) ) exit;



/* ==========================================================================
   Add WPB WooCommerce Product Slider Widget Clss
   ========================================================================== */

class wpb_woo_product_slider_Widget extends WP_Widget {

	/**
	 * Register widget with WordPress.
	 */
	function __construct() {
		parent::__construct(
			'wpb_woo_product_slider_widget', // Base ID
			__( 'WPB WooCommerce Product Slider', 'wpb-woocommerce-product-slider' ), // Name
			array( 'description' => __( 'Dispay product slider of WooCommerce products.', 'wpb-woocommerce-product-slider' ), ) // Args
		);
	}

	/**
	 * Front-end display of widget.
	 *
	 * @see WP_Widget::widget()
	 *
	 * @param array $args     Widget arguments.
	 * @param array $instance Saved values from database.
	 */
	public function widget( $args, $instance ) {

		extract( $args );
		extract( $instance );

		echo $before_widget;

		if ( ! empty( $title ) ) {
			echo $before_title . apply_filters( 'widget_title', $title ). $after_title;
		}

		switch ( $product_type ) {
		    case "latest":
		        $product_type_output = '';
		        break;
		    case "featured":
		        $product_type_output = 'featured="yes"';
		        break;
		    case "category":
		        $product_type_output = 'category="'.$product_category.'"';
		        break;
		    case "id":
		        $product_type_output = 'id="'.$product_id.'"';
		        break;
		    case "skus":
		        $product_type_output = 'skus="'.$product_skus.'"';
		        break;            

		    default:
		         $product_type_output = '';
		}

		echo do_shortcode( '[wpb-product-slider theme="'.$theme.'" autoplay="'. ( $autoplay == 'on' ? 'true' : 'false' ) .'" orderby="'.$orderby.'" order="'.$order.'" items="'.$items.'" product_type="'.$product_type.'" '. $product_type_output .' width="'.$width.'" height="'.$height.'" crop="true" nav="'. ( $navigation == 'on' ? 'true' : 'false' ) .'" pagination="'. ( $pagination == 'on' ? 'true' : 'false' ) .'" posts="'.$posts.'" items_desktop="'.$items_desktop.'" items_desktop_small="'.$items_desktop_small.'" items_tablet="'.$items_tablet.'" items_mobile="'.$items_mobile.'" ]' );

		echo $after_widget;
	}

	/**
	 * Back-end widget form.
	 *
	 * @see WP_Widget::form()
	 *
	 * @param array $instance Previously saved values from database.
	 */
	public function form( $instance ) {
		extract( $instance );
		if( !isset( $theme ) ){
			$theme = 'grid cs-style-3';
		}
		if( !isset( $orderby ) ){
			$orderby = 'none';
		}
		if( !isset( $order ) ){
			$order = 'ASC';
		}
		if( !isset( $product_type ) ){
			$product_type = 'latest';
		}
		if( !isset( $autoplay ) ){
			$autoplay = 'on';
		}
		if( !isset( $width ) ){
			$width = 320;
		}
		if( !isset( $height ) ){
			$height = 300;
		}
		if( !isset( $posts ) ){
			$posts = 10;
		}
		if( !isset( $items ) ){
			$items = 1;
		}
		if( !isset( $items_desktop ) ){
			$items_desktop = 1;
		}
		if( !isset( $items_desktop_small ) ){
			$items_desktop_small = 1;
		}
		if( !isset( $items_tablet ) ){
			$items_tablet = 1;
		}
		if( !isset( $items_mobile ) ){
			$items_mobile = 1;
		}
		if( !isset( $navigation ) ){
			$navigation = 'on';
		}
		if( !isset( $pagination ) ){
			$pagination = '';
		}
		if( !isset( $product_category ) ){
			$product_category = '';
		}
		if( !isset( $product_id ) ){
			$product_id = '';
		}
		if( !isset( $product_skus ) ){
			$product_skus = '';
		}
		?>

		<p>
			<label for="<?php echo $this->get_field_id( 'title' ); ?>"><?php _e( 'Title:','wpb-woocommerce-product-slider' ); ?></label> 
			<input class="widefat" id="<?php echo $this->get_field_id( 'title' ); ?>" name="<?php echo $this->get_field_name( 'title' ); ?>" type="text" value="<?php if( isset( $title ) ) echo esc_attr( $title ); ?>">
		</p>

		<p>
			<label for="<?php echo $this->get_field_id( 'theme' ); ?>"><?php _e( 'Theme:','wpb-woocommerce-product-slider' ); ?></label> 
			<select class="widefat" id="<?php echo $this->get_field_id( 'theme' ); ?>" name="<?php echo $this->get_field_name( 'theme' ); ?>">
				<option value="grid cs-style-3" <?php if( $theme && $theme == 'grid cs-style-3' ) echo 'selected';?>><?php _e( 'Hover','wpb-woocommerce-product-slider' ); ?></option>
				<option value="ben-box" <?php if( $theme && $theme == 'ben-box' ) echo 'selected';?>><?php _e( 'Box','wpb-woocommerce-product-slider' ); ?></option>
			</select>
		</p>

		<p>
			<input class="checkbox" type="checkbox" id="<?php echo $this->get_field_id( 'autoplay' ); ?>" name="<?php echo $this->get_field_name( 'autoplay' ); ?>" <?php if( $autoplay == 'on' ) echo 'checked';?>>
			<label for="<?php echo $this->get_field_id( 'autoplay' ); ?>"><?php _e( 'Slider Auto Play','wpb-woocommerce-product-slider' ); ?></label>
		</p>

		<p>
			<label for="<?php echo $this->get_field_id( 'width' ); ?>"><?php _e( 'Product Image Width:','wpb-woocommerce-product-slider' ); ?></label> 
			<input class="widefat" id="<?php echo $this->get_field_id( 'width' ); ?>" name="<?php echo $this->get_field_name( 'width' ); ?>" type="number" value="<?php echo esc_attr( $width ); ?>" required>
			<span class="wpb_widget_help"><?php _e( 'Default Width 320px. Uploaded image must be larger than the define size here.','wpb-woocommerce-product-slider' ); ?></span>
		</p>

		<p>
			<label for="<?php echo $this->get_field_id( 'height' ); ?>"><?php _e( 'Product Image Height:','wpb-woocommerce-product-slider' ); ?></label> 
			<input class="widefat" id="<?php echo $this->get_field_id( 'height' ); ?>" name="<?php echo $this->get_field_name( 'height' ); ?>" type="number" value="<?php echo esc_attr( $height ); ?>" required>
			<span class="wpb_widget_help"><?php _e( 'Default Height 300px. Uploaded image must be larger than the define size here.','wpb-woocommerce-product-slider' ); ?></span>
		</p>

		<p class="wpb_wps_product_type">
			<label for="<?php echo $this->get_field_id( 'product_type' ); ?>"><?php _e( 'Product Slider Type:','wpb-woocommerce-product-slider' ); ?></label> 
			<select class="widefat wpb_wps_product_type_select" id="<?php echo $this->get_field_id( 'product_type' ); ?>" name="<?php echo $this->get_field_name( 'product_type' ); ?>">
				<option value="latest" <?php if( $product_type && $product_type == 'latest' ) echo 'selected';?>><?php _e( 'Latest Products','wpb-woocommerce-product-slider' ); ?></option>
				<option value="featured" <?php if( $product_type && $product_type == 'featured' ) echo 'selected';?>><?php _e( 'Featured Products','wpb-woocommerce-product-slider' ); ?></option>
				<option value="category" <?php if( $product_type && $product_type == 'category' ) echo 'selected';?>><?php _e( 'Category Products','wpb-woocommerce-product-slider' ); ?></option>
				<option value="id" <?php if( $product_type && $product_type == 'id' ) echo 'selected';?>><?php _e( 'Products by id','wpb-woocommerce-product-slider' ); ?></option>
				<option value="skus"  <?php if( $product_type && $product_type == 'skus' ) echo 'selected';?>><?php _e( 'Products by SKU','wpb-woocommerce-product-slider' ); ?></option>
				<option value="on_sell"  <?php if( $product_type && $product_type == 'on_sell' ) echo 'selected';?>><?php _e( 'On Sell Products','wpb-woocommerce-product-slider' ); ?></option>
			</select>
		</p>

		<p class="wpb_wps_product_category">
			<label for="<?php echo $this->get_field_id( 'product_category' ); ?>"><?php _e( 'Product Category:','wpb-woocommerce-product-slider' ); ?></label> 
			<textarea class="widefat" id="<?php echo $this->get_field_id( 'product_category' ); ?>" name="<?php echo $this->get_field_name( 'product_category' ); ?>" row="4"><?php if( isset( $product_category ) ) echo esc_attr( $product_category ); ?></textarea>
			<span class="wpb_widget_help"><?php _e( 'Comma separated product category slugs. Needed only when product type will be Category Products.','wpb-woocommerce-product-slider' ); ?></span>
		</p>

		<p class="wpb_wps_product_id">
			<label for="<?php echo $this->get_field_id( 'product_id' ); ?>"><?php _e( 'Product ID:','wpb-woocommerce-product-slider' ); ?></label> 
			<textarea class="widefat" id="<?php echo $this->get_field_id( 'product_id' ); ?>" name="<?php echo $this->get_field_name( 'product_id' ); ?>" row="4"><?php if( isset( $product_id ) ) echo esc_attr( $product_id ); ?></textarea>
			<span class="wpb_widget_help"><?php _e( 'Comma separated product ID\'s. Needed only when product type will be Products by ID.','wpb-woocommerce-product-slider' ); ?></span>
		</p>

		<p class="wpb_wps_product_skus">
			<label for="<?php echo $this->get_field_id( 'product_skus' ); ?>"><?php _e( 'Product SKU:','wpb-woocommerce-product-slider' ); ?></label> 
			<textarea class="widefat" id="<?php echo $this->get_field_id( 'product_skus' ); ?>" name="<?php echo $this->get_field_name( 'product_skus' ); ?>" row="4"><?php if( isset( $product_skus ) ) echo esc_attr( $product_skus ); ?></textarea>
			<span class="wpb_widget_help"><?php _e( 'Comma separated product SKU\'s. Needed only when product type will be Products by SKU.','wpb-woocommerce-product-slider' ); ?></span>
		</p>

		<p>
			<label for="<?php echo $this->get_field_id( 'posts' ); ?>"><?php _e( 'Number of Products to Show:','wpb-woocommerce-product-slider' ); ?></label> 
			<input class="widefat" id="<?php echo $this->get_field_id( 'posts' ); ?>" name="<?php echo $this->get_field_name( 'posts' ); ?>" type="number" value="<?php echo esc_attr( $posts ); ?>" required>
			<span class="wpb_widget_help"><?php _e( 'Default 10. Use -1 to show all.','wpb-woocommerce-product-slider' ); ?></span>
		</p>

		<p>
			<label for="<?php echo $this->get_field_id( 'items' ); ?>"><?php _e( 'Number of Columns:','wpb-woocommerce-product-slider' ); ?></label> 
			<input class="widefat" id="<?php echo $this->get_field_id( 'items' ); ?>" name="<?php echo $this->get_field_name( 'items' ); ?>" type="number" value="<?php echo esc_attr( $items ); ?>" required>
			<span class="wpb_widget_help"><?php _e( 'Number of columns of in slider. Default 1 column.','wpb-woocommerce-product-slider' ); ?></span>
		</p>

		<p>
			<label for="<?php echo $this->get_field_id( 'items_desktop' ); ?>"><?php _e( 'Number of Columns in Medium Desktop:','wpb-woocommerce-product-slider' ); ?></label> 
			<input class="widefat" id="<?php echo $this->get_field_id( 'items_desktop' ); ?>" name="<?php echo $this->get_field_name( 'items_desktop' ); ?>" type="number" value="<?php echo esc_attr( $items_desktop ); ?>" required>
			<span class="wpb_widget_help"><?php _e( 'Screen size 1199px. Default 1 column.','wpb-woocommerce-product-slider' ); ?></span>
		</p>

		<p>
			<label for="<?php echo $this->get_field_id( 'items_desktop_small' ); ?>"><?php _e( 'Number of Columns in Small Desktop:','wpb-woocommerce-product-slider' ); ?></label> 
			<input class="widefat" id="<?php echo $this->get_field_id( 'items_desktop_small' ); ?>" name="<?php echo $this->get_field_name( 'items_desktop_small' ); ?>" type="number" value="<?php echo esc_attr( $items_desktop_small ); ?>" required>
			<span class="wpb_widget_help"><?php _e( 'Screen size 979px. Default 1 column.','wpb-woocommerce-product-slider' ); ?></span>
		</p>

		<p>
			<label for="<?php echo $this->get_field_id( 'items_tablet' ); ?>"><?php _e( 'Number of Columns in Tablet Screen:','wpb-woocommerce-product-slider' ); ?></label> 
			<input class="widefat" id="<?php echo $this->get_field_id( 'items_tablet' ); ?>" name="<?php echo $this->get_field_name( 'items_tablet' ); ?>" type="number" value="<?php echo esc_attr( $items_tablet ); ?>" required>
			<span class="wpb_widget_help"><?php _e( 'Screen size 768px. Default 1 column.','wpb-woocommerce-product-slider' ); ?></span>
		</p>

		<p>
			<label for="<?php echo $this->get_field_id( 'items_mobile' ); ?>"><?php _e( 'Number of Columns in Mobile Screen:','wpb-woocommerce-product-slider' ); ?></label> 
			<input class="widefat" id="<?php echo $this->get_field_id( 'items_mobile' ); ?>" name="<?php echo $this->get_field_name( 'items_mobile' ); ?>" type="number" value="<?php echo esc_attr( $items_mobile ); ?>" required>
			<span class="wpb_widget_help"><?php _e( 'Screen size 479px. Default 1 column.','wpb-woocommerce-product-slider' ); ?></span>
		</p>

		<p>
			<input class="checkbox" type="checkbox" id="<?php echo $this->get_field_id( 'navigation' ); ?>" name="<?php echo $this->get_field_name( 'navigation' ); ?>" <?php if( $navigation == 'on' ) echo 'checked';?>>
			<label for="<?php echo $this->get_field_id( 'navigation' ); ?>"><?php _e( 'Slider Navigation. Default On.','wpb-woocommerce-product-slider' ); ?></label>
		</p>

		<p>
			<input class="checkbox" type="checkbox" id="<?php echo $this->get_field_id( 'pagination' ); ?>" name="<?php echo $this->get_field_name( 'pagination' ); ?>" <?php if( $pagination == 'on' ) echo 'checked';?>>
			<label for="<?php echo $this->get_field_id( 'pagination' ); ?>"><?php _e( 'Slider Pagination. Default Off.','wpb-woocommerce-product-slider' ); ?></label>
		</p>

		<p>
			<label for="<?php echo $this->get_field_id( 'orderby' ); ?>"><?php _e( 'Products Orderby:','wpb-woocommerce-product-slider' ); ?></label> 
			<select class="widefat" id="<?php echo $this->get_field_id( 'orderby' ); ?>" name="<?php echo $this->get_field_name( 'orderby' ); ?>">
				<option value="none" <?php if( $orderby && $orderby == 'none' ) echo 'selected';?>><?php _e( 'None','wpb-woocommerce-product-slider' ); ?></option>
				<option value="ID" <?php if( $orderby && $orderby == 'ID' ) echo 'selected';?>><?php _e( 'ID','wpb-woocommerce-product-slider' ); ?></option>
				<option value="author" <?php if( $orderby && $orderby == 'author' ) echo 'selected';?>><?php _e( 'Author','wpb-woocommerce-product-slider' ); ?></option>
				<option value="title" <?php if( $orderby && $orderby == 'title' ) echo 'selected';?>><?php _e( 'Title','wpb-woocommerce-product-slider' ); ?></option>
				<option value="name" <?php if( $orderby && $orderby == 'name' ) echo 'selected';?>><?php _e( 'Name','wpb-woocommerce-product-slider' ); ?></option>
				<option value="date" <?php if( $orderby && $orderby == 'date' ) echo 'selected';?>><?php _e( 'Date','wpb-woocommerce-product-slider' ); ?></option>
				<option value="rand" <?php if( $orderby && $orderby == 'rand' ) echo 'selected';?>><?php _e( 'Rand','wpb-woocommerce-product-slider' ); ?></option>
				<option value="menu_order" <?php if( $orderby && $orderby == 'menu_order' ) echo 'selected';?>><?php _e( 'Menu order','wpb-woocommerce-product-slider' ); ?></option>
			</select>
		</p>

		<p>
			<label for="<?php echo $this->get_field_id( 'order' ); ?>"><?php _e( 'Products order:','wpb-woocommerce-product-slider' ); ?></label> 
			<select class="widefat" id="<?php echo $this->get_field_id( 'order' ); ?>" name="<?php echo $this->get_field_name( 'order' ); ?>">
				<option value="ASC" <?php if( $order && $order == 'ASC' ) echo 'selected';?>><?php _e( 'Ascending','wpb-woocommerce-product-slider' ); ?></option>
				<option value="DESC" <?php if( $order && $order == 'DESC' ) echo 'selected';?>><?php _e( 'Descending','wpb-woocommerce-product-slider' ); ?></option>
			</select>
		</p>
		<?php 
	}

	/**
	 * Sanitize widget form values as they are saved.
	 *
	 * @see WP_Widget::update()
	 *
	 * @param array $new_instance Values just sent to be saved.
	 * @param array $old_instance Previously saved values from database.
	 *
	 * @return array Updated safe values to be saved.
	 */
	public function update( $new_instance, $old_instance ) {
		$instance = array();
		$instance['title'] = ( ! empty( $new_instance['title'] ) ) ? strip_tags( $new_instance['title'] ) : '';
		$instance['theme'] = ( ! empty( $new_instance['theme'] ) ) ? strip_tags( $new_instance['theme'] ) : '';
		$instance['autoplay'] = ( ! empty( $new_instance['autoplay'] ) ) ? strip_tags( $new_instance['autoplay'] ) : '';
		$instance['width'] = ( ! empty( $new_instance['width'] ) ) ? strip_tags( $new_instance['width'] ) : '';
		$instance['height'] = ( ! empty( $new_instance['height'] ) ) ? strip_tags( $new_instance['height'] ) : '';
		$instance['posts'] = ( ! empty( $new_instance['posts'] ) ) ? strip_tags( $new_instance['posts'] ) : '';
		$instance['items'] = ( ! empty( $new_instance['items'] ) ) ? strip_tags( $new_instance['items'] ) : '';
		$instance['items_desktop'] = ( ! empty( $new_instance['items_desktop'] ) ) ? strip_tags( $new_instance['items_desktop'] ) : '';
		$instance['items_desktop_small'] = ( ! empty( $new_instance['items_desktop_small'] ) ) ? strip_tags( $new_instance['items_desktop_small'] ) : '';
		$instance['items_tablet'] = ( ! empty( $new_instance['items_tablet'] ) ) ? strip_tags( $new_instance['items_tablet'] ) : '';
		$instance['items_mobile'] = ( ! empty( $new_instance['items_mobile'] ) ) ? strip_tags( $new_instance['items_mobile'] ) : '';
		$instance['navigation'] = ( ! empty( $new_instance['navigation'] ) ) ? strip_tags( $new_instance['navigation'] ) : '';
		$instance['pagination'] = ( ! empty( $new_instance['pagination'] ) ) ? strip_tags( $new_instance['pagination'] ) : '';
		$instance['orderby'] = ( ! empty( $new_instance['orderby'] ) ) ? strip_tags( $new_instance['orderby'] ) : '';
		$instance['order'] = ( ! empty( $new_instance['order'] ) ) ? strip_tags( $new_instance['order'] ) : '';
		$instance['product_type'] = ( ! empty( $new_instance['product_type'] ) ) ? strip_tags( $new_instance['product_type'] ) : '';
		$instance['product_category'] = ( ! empty( $new_instance['product_category'] ) ) ? strip_tags( $new_instance['product_category'] ) : '';
		$instance['product_id'] = ( ! empty( $new_instance['product_id'] ) ) ? strip_tags( $new_instance['product_id'] ) : '';
		$instance['product_skus'] = ( ! empty( $new_instance['product_skus'] ) ) ? strip_tags( $new_instance['product_skus'] ) : '';

		return $instance;
	}

} // class wpb_woo_product_slider_Widget




/* ==========================================================================
   register wpb_woo_product_slider_Widget widget
   ========================================================================== */

function register_wpb_woo_product_slider_widget() {
    register_widget( 'wpb_woo_product_slider_Widget' );
}
add_action( 'widgets_init', 'register_wpb_woo_product_slider_widget' );