<?php

/*
	WPB Filterable Portfolio
	By WPBean
	
*/

if ( ! defined( 'ABSPATH' ) ) exit; // Exit if accessed directly 


/**
 * Shortcode Generator Scripts
 */

add_action( 'admin_enqueue_scripts', 'wpb_wps_shortcode_generate_enqueue_scripts' );

function wpb_wps_shortcode_generate_enqueue_scripts() {
	$screen = get_current_screen();

	if( $screen->id == 'wpb_wps_shortcode' && $screen->post_type == 'wpb_wps_shortcode' && $screen->base == 'post' ){
		wp_enqueue_script( 'wpb_wps_depends_on', plugins_url('../admin/assets/js/dependsOn-1.0.2.min.js', __FILE__), array('jquery'), '1.0.2', false );
   		wp_enqueue_script( 'wpb-wps-shortcode-generator', plugins_url('../admin/assets/js/wpb-wps-shortcode-generator.js', __FILE__), array('jquery'), '1.0', false );
	}
    
	if( $screen->id == 'wpb_wps_shortcode' && $screen->post_type == 'wpb_wps_shortcode' && $screen->base == 'post' || $screen->base == 'toplevel_page_wpb_woo_product_slider' ){
		wp_enqueue_script( 'wpb_wps_rcswitcher', plugins_url('../admin/assets/js/rcswitcher.min.js', __FILE__), array('jquery'), '1.0', false );
    	wp_enqueue_style( 'wpb_wps_rcswitcher_style', plugins_url('../admin/assets/css/rcswitcher.min.css', __FILE__), '', '1.0', false);
	}
}


/**
 * Shortcode Generator
 */

function wpb_wps_shortcode_generate_post_type() {

	$labels = array(
		'name'                => _x( 'Shortcode Generator', 'Post Type General Name', 'wpb-woocommerce-product-slider' ),
		'singular_name'       => _x( 'Shortcode Generator', 'Post Type Singular Name', 'wpb-woocommerce-product-slider' ),
		'menu_name'           => __( 'Shortcode Generator', 'wpb-woocommerce-product-slider' ),
		'name_admin_bar'      => __( 'Shortcode Generator', 'wpb-woocommerce-product-slider' ),
		'parent_item_colon'   => __( 'Parent Product Slider Shortcode:', 'wpb-woocommerce-product-slider' ),
		'all_items'           => __( 'Product Slider Shortcodes', 'wpb-woocommerce-product-slider' ),
		'add_new_item'        => __( 'Add New Product Slider Shortcode', 'wpb-woocommerce-product-slider' ),
		'add_new'             => __( 'Add New Shortcode', 'wpb-woocommerce-product-slider' ),
		'new_item'            => __( 'New Product Slider Shortcode', 'wpb-woocommerce-product-slider' ),
		'edit_item'           => __( 'Edit Product Slider Shortcode', 'wpb-woocommerce-product-slider' ),
		'update_item'         => __( 'Update Product Slider Shortcode', 'wpb-woocommerce-product-slider' ),
		'view_item'           => __( 'View Product Slider Shortcode', 'wpb-woocommerce-product-slider' ),
		'search_items'        => __( 'Search Product Slider Shortcode', 'wpb-woocommerce-product-slider' ),
		'not_found'           => __( 'Not found', 'wpb-woocommerce-product-slider' ),
		'not_found_in_trash'  => __( 'Not found in Trash', 'wpb-woocommerce-product-slider' ),
	);
	$args = array(
		'label'               => __( 'Product Slider Shortcode', 'wpb-woocommerce-product-slider' ),
		'description'         => __( 'Post Type For Product Slider Shortcode Generator ', 'wpb-woocommerce-product-slider' ),
		'labels'              => $labels,
		'supports'            => array( 'title', ),
		'taxonomies'          => array(),
		'hierarchical'        => false,
		'public'              => false,
		'show_ui'             => true,
		'show_in_menu'        => false,
		'menu_position'       => 5,
		'show_in_admin_bar'   => false,
		'show_in_nav_menus'   => false,
		'can_export'          => true,
		'has_archive'         => false,		
		'exclude_from_search' => true,
		'publicly_queryable'  => false,
		'capability_type'     => 'page',
	);
	register_post_type( 'wpb_wps_shortcode', $args );

}
add_action( 'init', 'wpb_wps_shortcode_generate_post_type', 0 );


/**
 * Adding The shortcode generator to the product slider sub menu
 */

add_action( 'admin_menu', 'wpb_woo_shortcode_generator_' );
 
function wpb_woo_shortcode_generator_(){
 
    global $submenu;

    $submenu['wpb_woo_product_slider']['wpb_woo_shortcode_generator'] = array(
        sprintf( '%s%s%s', '<span id="wpb_woo_shortcode_generator">', __( 'Shortcode Generator', 'wpb-woocommerce-product-slider' ), '</span>' ),
        'install_plugins',
        'edit.php?post_type=wpb_wps_shortcode',
        __( 'Shortcode Generator', 'wpb-woocommerce-product-slider' ),
    );

}


/**
 * Post Type Title for Portfolio Shortcode 
 */

function wpb_wps_change_default_title_placeholder( $title ){
    $screen = get_current_screen();
    if ( 'wpb_wps_shortcode' == $screen->post_type ){
        $title = __( 'Shortcode Name','wpb-woocommerce-product-slider' );
    }
    return $title;
}
add_filter( 'enter_title_here', 'wpb_wps_change_default_title_placeholder' );


/**
 * Post Type Title for Portfolio Shortcode 
 */

function wpb_wps_change_default_post_update_message( $message ){
    $screen = get_current_screen();
    if ( 'wpb_wps_shortcode' == $screen->post_type ){
       $message['post'][1] = $title = __( 'Shortcode updated.','wpb-woocommerce-product-slider' );
       $message['post'][4] = $title = __( 'Shortcode updated.','wpb-woocommerce-product-slider' );
       $message['post'][6] = $title = __( 'Shortcode published.','wpb-woocommerce-product-slider' );
       $message['post'][8] = $title = __( 'Shortcode submitted.','wpb-woocommerce-product-slider' );
       $message['post'][10] = $title = __( 'Shortcode draft updated.','wpb-woocommerce-product-slider' );
    }
    return $message;
}
add_filter( 'post_updated_messages', 'wpb_wps_change_default_post_update_message' );



/**
 * Getting ready category for the shortcode generator checkbox group
 */


function wpb_wps_tax_for_checkbox_group_meta ( $taxonomy ){
	global $post;
    $terms = get_terms( $taxonomy );
    $output = array();
    foreach ( $terms as $term ) {
    	$output[$term->term_id] = array( 
    		'label' => $term->name,
			'value'	=> $term->term_id,
    	);
    }
    return $output;
}

/**
 * Getting ready SKUs for the shortcode generator checkbox group
 */


function wpb_wps_skus_for_checkbox_group_meta (){
	
	global $wpdb;
	$key = '_sku';
	$type = 'product';
	$status = 'publish';

    if( empty( $key ) )
        return;

    $skus = $wpdb->get_col( $wpdb->prepare( "
        SELECT pm.meta_value FROM {$wpdb->postmeta} pm
        LEFT JOIN {$wpdb->posts} p ON p.ID = pm.post_id
        WHERE pm.meta_key = '%s' 
        AND p.post_status = '%s' 
        AND p.post_type = '%s'
    ", $key, $status, $type ) );

    $output = array();
    foreach ( $skus as $sku ) {
    	if( $sku && !empty($sku) ){
    		$output[$sku] = array( 
	    		'label' => $sku,
				'value'	=> $sku,
	    	);
    	}
    }
    return $output;

}


/**
 * Getting ready attribute for the shortcode generator checkbox
 */

function wpb_wps_attribute_for_meta_options(){
	global $wpdb;
	$key = '_product_attributes';
	$type = 'product';
	$status = 'publish';

    if( empty( $key ) )
        return;

    $attributes = $wpdb->get_col( $wpdb->prepare( "
        SELECT pm.meta_value FROM {$wpdb->postmeta} pm
        LEFT JOIN {$wpdb->posts} p ON p.ID = pm.post_id
        WHERE pm.meta_key = '%s' 
        AND p.post_status = '%s' 
        AND p.post_type = '%s'
    ", $key, $status, $type ) );

    $outputs = array();
    foreach ( $attributes as $attribute ) {
    	if( $attribute && !empty($attribute) ){
    		$outputs[] = unserialize($attribute);
    	}
    }

    $outputs_again = array();
    foreach ( $outputs as $output ) {
    	if( $output && !empty($output) ){
        	$outputs_again[] = array_keys($output);
    	}
    }

    $final = array();
    foreach ($outputs_again as $output_again) {

    	if( $output_again && !empty($output_again) ){

	    	foreach ( $output_again as $output_once_again ) {

	    		if( $output_once_again && !empty($output_once_again) ){
	    			$final[] = $output_once_again;
	    		}

	    	}

    	}

    }

    if( $final && !empty($final) ){
    	$final = array_unique($final);
    }

    $final_output = array();
    foreach ( $final as $final_value ) {

    	if( $final_value && !empty($final_value) ){

    		$final_output[$final_value] = array( 
	    		'label' => $final_value,
				'value'	=> $final_value,
	    	);

    	}

    }


    return apply_filters( 'wpb_wps_attribute_for_meta_options', $final_output );
}



/**
 * Adding the taxonomty added attribute filters to the shortcode generator
 * Since: v 3.05.6
 */

add_filter( 'wpb_wps_attribute_filters_for_meta_options', 'wpb_wps_texonomy_attribute_filters_for_meta_options' );

function wpb_wps_texonomy_attribute_filters_for_meta_options( $attributes ){
	$attribute_taxonomies = wc_get_attribute_taxonomies();

	$taxonomy_terms = $tax_attr_filters = array();

	if ( $attribute_taxonomies ) :
		foreach ($attribute_taxonomies as $tax) :
			if (taxonomy_exists(wc_attribute_taxonomy_name($tax->attribute_name))) :
				$taxonomy_terms[$tax->attribute_name] = get_terms( wc_attribute_taxonomy_name( $tax->attribute_name ), 'orderby=name&hide_empty=0' );
			endif;
		endforeach;
	endif;

	
    foreach ( $taxonomy_terms as $taxonomy_term ) {

    	if( $taxonomy_term && !empty( $taxonomy_term ) ){
    		foreach ($taxonomy_term as $attribute_filter ) {
    			$tax_attr_filters[$attribute_filter->slug] = array( 
					'label' => $attribute_filter->name,
					'value'	=> $attribute_filter->slug,
				);
    		}
    	}

    }

    $merge = array_merge( $attributes, $tax_attr_filters );

    $unique = array_map( 'unserialize', array_unique( array_map( 'serialize', $merge) ) );

    return $unique;

	exit;
}


/**
 * Getting ready attribute filters for the shortcode generator
 */

function wpb_wps_attribute_filters_for_meta_options(){
	global $wpdb;
	$key = '_product_attributes';
	$type = 'product';
	$status = 'publish';

    if( empty( $key ) )
        return;

    $attributes = $wpdb->get_col( $wpdb->prepare( "
        SELECT pm.meta_value FROM {$wpdb->postmeta} pm
        LEFT JOIN {$wpdb->posts} p ON p.ID = pm.post_id
        WHERE pm.meta_key = '%s' 
        AND p.post_status = '%s' 
        AND p.post_type = '%s'
    ", $key, $status, $type ) );

    $outputs = array();
    foreach ( $attributes as $attribute ) {
    	if( $attribute && !empty($attribute) ){
    		$outputs[] = unserialize($attribute);
    	}
    }

    $outputs_again = array();
    foreach ( $outputs as $output ) {
    	if( $output && !empty($output) ){
        	$outputs_again[] = $output;
    	}
    }

    $final = array();
    foreach ($outputs_again as $output_again) {

    	if( $output_again && !empty($output_again) ){

	    	foreach ( $output_again as $output_once_again ) {

	    		if( $output_once_again && !empty($output_once_again) ){
	    			if( $output_once_again['value'] != '' ){
	    				$final[] = $output_once_again['value'];
	    			}

	    		}

	    	}

    	}

    }

    if( $final && !empty($final) ){
    	$final = implode(' | ',$final);
	    $final = explode(' | ', $final);
	    $final = array_unique($final);
    }

    $final_output = array();

    foreach ( $final as $final_value ) {

    	if( $final_value && !empty($final_value) ){

    		$final_output[sanitize_title($final_value)] = array( 
	    		'label' => $final_value,
				'value'	=> sanitize_title($final_value),
	    	);

    	}

    }

    return apply_filters( 'wpb_wps_attribute_filters_for_meta_options', $final_output );
}



/**
 * Getting ready products for the shortcode generator
 */

function wpb_wps_posts_for_chosen_options( $post_type ){

	$args = array(
		'post_type'             => $post_type,
		'post_status'           => 'publish',
		'ignore_sticky_posts'   => 1,
		'posts_per_page'        => -1,
	);

    $posts = get_posts($args);

    $output = array();
    
    foreach ( $posts as $post ) {
    	$output[$post->ID] = array( 
    		'label' => '#'.$post->ID.' - '.$post->post_title,
			'value'	=> $post->ID,
    	);
    }

    if( !$output ){
    	$output['no-post-found'] = array( 
			'label' => __( 'No Post Found', 'wpb-woocommerce-product-slider' ),
			'value'	=> 'no-post-found',
		);
    }

    return $output;
}




/**
 * Shortcode Generator meta
 */

add_action( 'admin_init', 'wpb_wps_shortcode_generator_metaboxes' );

function wpb_wps_shortcode_generator_metaboxes(){
	$prefix = 'wpb_wps_';
	$post_type = 'wpb_wps_shortcode';
	$wpb_wps_taxonomy = 'product_cat';

	$fields = array(
		array(
			'label' 		=> __( 'Shortcode', 'wpb-woocommerce-product-slider' ),
			'desc'  		=> __( 'Shortcode to use.', 'wpb-woocommerce-product-slider' ),
			'id'    		=> $prefix.'shortcode',
			'type'  		=> 'shortcode',
			'default_value' => 'wpb-product-slider-shortcode'
		),
		array(
			'label'			=> __( 'Slider Title', 'wpb-woocommerce-product-slider' ),
			'id'			=> $prefix.'title',
			'type'			=> 'text',
		),
		array(
			'label'	=> __( 'Slider Theme', 'wpb-woocommerce-product-slider' ),
			'desc'	=> __( 'Choose a theme for the slider.', 'wpb-woocommerce-product-slider' ),
			'id'	=> $prefix.'theme',
			'type'	=> 'select',
			'options' => array (
				'grid cs-style-3' => array (
					'label' => __( 'Hover', 'wpb-woocommerce-product-slider' ),
					'value'	=> 'grid cs-style-3'
				),
				'ben-box' => array (
					'label' => __( 'Ben Box', 'wpb-woocommerce-product-slider' ),
					'value'	=> 'ben-box'
				),
				'fashion' => array (
					'label' => __( 'Fashion', 'wpb-woocommerce-product-slider' ),
					'value'	=> 'fashion'
				),
				'black' => array (
					'label' => __( 'Black', 'wpb-woocommerce-product-slider' ),
					'value'	=> 'black'
				),
				'jupiter' => array (
					'label' => __( 'Jupiter', 'wpb-woocommerce-product-slider' ),
					'value'	=> 'jupiter'
				),
				'mars' => array (
					'label' => __( 'Mars', 'wpb-woocommerce-product-slider' ),
					'value'	=> 'mars'
				),
			)
		),
		array(
			'label'	=> __( 'Product Type', 'wpb-woocommerce-product-slider' ),
			'desc'	=> __( 'Select a type for the slider.', 'wpb-woocommerce-product-slider' ),
			'id'	=> $prefix.'product_type',
			'type'	=> 'select',
			'options' => array (
				'latest' => array (
					'label' => __( 'Latest Product Slider', 'wpb-woocommerce-product-slider' ),
					'value'	=> 'latest'
				),
				'featured' => array (
					'label' => __( 'Featured Product Slider', 'wpb-woocommerce-product-slider' ),
					'value'	=> 'featured'
				),
				'category' => array (
					'label' => __( 'Product Slider by Product Categories', 'wpb-woocommerce-product-slider' ),
					'value'	=> 'category'
				),
				'tags' => array (
					'label' => __( 'Product Slider by Product Tags', 'wpb-woocommerce-product-slider' ),
					'value'	=> 'tags'
				),
				'id' => array (
					'label' => __( 'Product Slider by specific products', 'wpb-woocommerce-product-slider' ),
					'value'	=> 'id'
				),
				'skus' => array (
					'label' => __( 'Product Slider by specific products skus', 'wpb-woocommerce-product-slider' ),
					'value'	=> 'skus'
				),
				'on_sell' => array (
					'label' => __( 'Product Slider by on sell products', 'wpb-woocommerce-product-slider' ),
					'value'	=> 'on_sell'
				),
				'attribute' => array (
					'label' => __( 'Product Slider by specific products attribute', 'wpb-woocommerce-product-slider' ),
					'value'	=> 'attribute'
				),
				'best_selling' => array (
					'label' => __( 'Product Slider by best selling products', 'wpb-woocommerce-product-slider' ),
					'value'	=> 'best_selling'
				),
			)
		),
		array(
			'label'					=> __( 'Select Products', 'wpb-woocommerce-product-slider' ),
			'desc'					=> __( 'Select products for the slider. Only selected products will be shown in the slider', 'wpb-woocommerce-product-slider' ),
			'id'					=> $prefix.'product_ids',
			'type'					=> 'chosen',
			'multiple'				=> true,
			'chosen_placeholder' 	=> __( 'Select products for the slider', 'wpb-woocommerce-product-slider' ),
			'options' 				=> wpb_wps_posts_for_chosen_options( 'product' ),
		),
		array (
			'label'		=> __( 'Product Category', 'wpb-woocommerce-product-slider' ),
			'desc'		=> __( 'Select product categoris, slider will shown by form this selected categoris.', 'wpb-woocommerce-product-slider' ),
			'id'		=> $prefix.'category',
			'type'		=> 'checkbox_group',
			'options' 	=> wpb_wps_tax_for_checkbox_group_meta( 'product_cat' ),
		),
		array (
			'label'		=> __( 'Product Category [ Exclude ]', 'wpb-woocommerce-product-slider' ),
			'desc'		=> __( 'Select product categoris, slider will exclude the selected categoris products.', 'wpb-woocommerce-product-slider' ),
			'id'		=> $prefix.'exclude_category',
			'type'		=> 'checkbox_group',
			'options' 	=> wpb_wps_tax_for_checkbox_group_meta( 'product_cat' ),
		),
		array (
			'label'		=> __( 'Product Tags', 'wpb-woocommerce-product-slider' ),
			'desc'		=> __( 'Select product tags, slider will shown by form form this selected tags.', 'wpb-woocommerce-product-slider' ),
			'id'		=> $prefix.'tags',
			'type'		=> 'checkbox_group',
			'options' 	=> wpb_wps_tax_for_checkbox_group_meta( 'product_tag' ),
		),
		array (
			'label'		=> __( 'Product Tags [ Exclude ]', 'wpb-woocommerce-product-slider' ),
			'desc'		=> __( 'Select product tags, slider will exclude the selected tags products.', 'wpb-woocommerce-product-slider' ),
			'id'		=> $prefix.'exclude_tags',
			'type'		=> 'checkbox_group',
			'options' 	=> wpb_wps_tax_for_checkbox_group_meta( 'product_tag' ),
		),
		array (
			'label'		=> __( 'Product SKUs', 'wpb-woocommerce-product-slider' ),
			'desc'		=> __( 'Select product SKUs for the slider.', 'wpb-woocommerce-product-slider' ),
			'id'		=> $prefix.'skus',
			'type'		=> 'checkbox_group',
			'options' 	=> wpb_wps_skus_for_checkbox_group_meta(),
		),
		array (
			'label'		=> __( 'Product attribute', 'wpb-woocommerce-product-slider' ),
			'desc'		=> __( 'Select product attribute for the slider.', 'wpb-woocommerce-product-slider' ),
			'id'		=> $prefix.'attribute',
			'type'		=> 'radio',
			'options' 	=> wpb_wps_attribute_for_meta_options(),
		),
		array (
			'label'					=> __( 'Attribute Filters', 'wpb-woocommerce-product-slider' ),
			'desc'					=> __( 'Select product attribute filters for the slider.', 'wpb-woocommerce-product-slider' ),
			'id'					=> $prefix.'filters',
			'type'					=> 'chosen',
			'multiple'				=> true,
			'chosen_placeholder' 	=> __( 'Select products attributes filters.', 'wpb-woocommerce-product-slider' ),
			'options' 				=> wpb_wps_attribute_filters_for_meta_options(),
		),
		array(
			'label'			=> __( 'Number of product', 'wpb-woocommerce-product-slider' ),
			'desc'			=> __( 'Number of product to show in the slider, default 10', 'wpb-woocommerce-product-slider' ),
			'id'			=> $prefix.'posts',
			'type'			=> 'slider',
			'min'			=> '-1',
			'max'			=> '100',
			'step'			=> '1',
			'default_value' => 10
		),
		array(
			'label'	=> __( 'Slider suto play', 'wpb-woocommerce-product-slider' ),
			'desc'	=> __( 'Default: On.', 'wpb-woocommerce-product-slider' ),
			'id'	=> $prefix.'autoplay',
			'type'	=> 'checkbox',
			'default_value'	=> 'on',
		),
		array(
			'label'			=> __( 'Slider auto play speed', 'wpb-woocommerce-product-slider' ),
			'desc'			=> __( 'Default 3000 milliseconds', 'wpb-woocommerce-product-slider' ),
			'id'			=> $prefix.'autoplay_speed',
			'type'			=> 'slider',
			'min'			=> '1000',
			'max'			=> '10000',
			'step'			=> '100',
			'default_value' => 3000
		),
		array(
			'label'			=> __( 'Slider orderby', 'wpb-woocommerce-product-slider' ),
			'desc'			=> __( 'Set slider products orderby.', 'wpb-woocommerce-product-slider' ),
			'id'			=> $prefix.'orderby',
			'type'			=> 'select',
			'options' 		=> array (
				'none' => array (
					'label' => __( 'none', 'wpb-woocommerce-product-slider' ),
					'value'	=> 'none'
				),
				'ID' => array (
					'label' => __( 'ID', 'wpb-woocommerce-product-slider' ),
					'value'	=> 'ID'
				),
				'title' => array (
					'label' => __( 'title', 'wpb-woocommerce-product-slider' ),
					'value'	=> 'title'
				),
				'name' => array (
					'label' => __( 'name', 'wpb-woocommerce-product-slider' ),
					'value'	=> 'name'
				),
				'date' => array (
					'label' => __( 'date', 'wpb-woocommerce-product-slider' ),
					'value'	=> 'date'
				),
				'modified' => array (
					'label' => __( 'modified', 'wpb-woocommerce-product-slider' ),
					'value'	=> 'modified'
				),
				'rand' => array (
					'label' => __( 'rand', 'wpb-woocommerce-product-slider' ),
					'value'	=> 'rand'
				),
				'comment_count' => array (
					'label' => __( 'comment_count', 'wpb-woocommerce-product-slider' ),
					'value'	=> 'comment_count'
				),
				'menu_order' => array (
					'label' => __( 'menu_order', 'wpb-woocommerce-product-slider' ),
					'value'	=> 'menu_order'
				),
				'menu_order' => array (
					'label' => __( 'menu_order', 'wpb-woocommerce-product-slider' ),
					'value'	=> 'menu_order'
				),
				'post__in' => array (
					'label' => __( 'post__in', 'wpb-woocommerce-product-slider' ),
					'value'	=> 'post__in'
				),
				'meta_value_num' => array (
					'label' => __( 'meta_value_num', 'wpb-woocommerce-product-slider' ),
					'value'	=> 'meta_value_num'
				),
			)
		),
		array(
			'label'			=> __( 'Slider order', 'wpb-woocommerce-product-slider' ),
			'desc'			=> __( 'Set slider products order.', 'wpb-woocommerce-product-slider' ),
			'id'			=> $prefix.'order',
			'type'			=> 'select',
			'options' 		=> array (
				'ASC' => array (
					'label' => __( 'ASC', 'wpb-woocommerce-product-slider' ),
					'value'	=> 'ASC'
				),
				'DESC' => array (
					'label' => __( 'DESC', 'wpb-woocommerce-product-slider' ),
					'value'	=> 'DESC'
				)
			)
		),
		array(
			'label'			=> __( 'Show Advance Options', 'wpb-woocommerce-product-slider' ),
			'desc'			=> __( 'Select yes for showing the advance settings.', 'wpb-woocommerce-product-slider' ),
			'id'			=> $prefix.'show_advance_settings',
			'type'			=> 'select',
			'options' 		=> array (
				'no' => array (
					'label' => __( 'No', 'wpb-woocommerce-product-slider' ),
					'value'	=> 'no'
				),
				'yes' => array (
					'label' => __( 'Yes', 'wpb-woocommerce-product-slider' ),
					'value'	=> 'yes'
				)
			)
		),
		array(
			'label'	=> __( 'Slider Navigation', 'wpb-woocommerce-product-slider' ),
			'desc'	=> __( 'Default: On.', 'wpb-woocommerce-product-slider' ),
			'id'	=> $prefix.'nav',
			'type'	=> 'checkbox',
			'default_value'	=> 'on',
		),
		array(
			'label'	=> __( 'Slider pagination', 'wpb-woocommerce-product-slider' ),
			'desc'	=> __( 'Default: Off.', 'wpb-woocommerce-product-slider' ),
			'id'	=> $prefix.'pagination',
			'type'	=> 'checkbox',
			'default_value'	=> 'off',
		),
		array(
			'label'			=> __( 'Number of products column on default screen', 'wpb-woocommerce-product-slider' ),
			'desc'			=> __( 'Default 4', 'wpb-woocommerce-product-slider' ),
			'id'			=> $prefix.'items',
			'type'			=> 'slider',
			'min'			=> '2',
			'max'			=> '10',
			'step'			=> '1',
			'default_value' => 4
		),
		array(
			'label'			=> __( 'Number of products column on screen size 1199px', 'wpb-woocommerce-product-slider' ),
			'desc'			=> __( 'Default 3', 'wpb-woocommerce-product-slider' ),
			'id'			=> $prefix.'items_desktop',
			'type'			=> 'slider',
			'min'			=> '2',
			'max'			=> '10',
			'step'			=> '1',
			'default_value' => 3
		),
		array(
			'label'			=> __( 'Number of products column on screen size 979px', 'wpb-woocommerce-product-slider' ),
			'desc'			=> __( 'Default 3', 'wpb-woocommerce-product-slider' ),
			'id'			=> $prefix.'items_desktop_small',
			'type'			=> 'slider',
			'min'			=> '2',
			'max'			=> '10',
			'step'			=> '1',
			'default_value' => 3
		),
		array(
			'label'			=> __( 'Number of products column on screen size 768px', 'wpb-woocommerce-product-slider' ),
			'desc'			=> __( 'Default 3', 'wpb-woocommerce-product-slider' ),
			'id'			=> $prefix.'items_tablet',
			'type'			=> 'slider',
			'min'			=> '1',
			'max'			=> '10',
			'step'			=> '1',
			'default_value' => 2
		),
		array(
			'label'			=> __( 'Number of products column on screen size 479px', 'wpb-woocommerce-product-slider' ),
			'desc'			=> __( 'Default 1', 'wpb-woocommerce-product-slider' ),
			'id'			=> $prefix.'items_mobile',
			'type'			=> 'slider',
			'min'			=> '1',
			'max'			=> '10',
			'step'			=> '1',
			'default_value' => 1
		),
		array(
			'label'			=> __( 'Product image width', 'wpb-woocommerce-product-slider' ),
			'desc'			=> __( 'Default 320px', 'wpb-woocommerce-product-slider' ),
			'id'			=> $prefix.'width',
			'type'			=> 'slider',
			'min'			=> '200',
			'max'			=> '1000',
			'step'			=> '1',
			'default_value' => 320
		),
		array(
			'label'			=> __( 'Product image height', 'wpb-woocommerce-product-slider' ),
			'desc'			=> __( 'Default 300px', 'wpb-woocommerce-product-slider' ),
			'id'			=> $prefix.'height',
			'type'			=> 'slider',
			'min'			=> '200',
			'max'			=> '1000',
			'step'			=> '1',
			'default_value' => 300
		),
		array(
			'label'	=> __( 'Product image hard crop', 'wpb-woocommerce-product-slider' ),
			'desc'	=> __( 'Default: Yes.', 'wpb-woocommerce-product-slider' ),
			'id'	=> $prefix.'crop',
			'type'	=> 'checkbox',
			'default_value'	=> 'on',
		),

	);

	/**
	* Instantiate the class with all variables to create a meta box
	* var $id string meta box id
	* var $title string title
	* var $fields array fields
	* var $page string|array post type to add meta box to
	* var $context The part of the page where the edit screen section should be shown ('normal', 'advanced', or 'side'). 
	*/

	$product_slider_metabox = new custom_add_meta_box( 'product_slider_options', __( 'Shortcode Options', 'wpb-woocommerce-product-slider' ), apply_filters( 'wpb_wps_shortcode_generator_metabox', $fields, $prefix ), $post_type, 'normal' );

}




/**
 * Registering the dynamic Generated Shortcode
 */

add_shortcode( 'wpb-product-slider-shortcode','wpb_wps_generated_shortcode_function' );

if( !function_exists('wpb_wps_generated_shortcode_function') ):
	function wpb_wps_generated_shortcode_function( $atts ){
		extract(shortcode_atts(array(
			'id'				=> '',
			'title'				=> ''
		), $atts));

		$edit_shortcode_link = wpb_wps_get_option( 'wpb_wps_edit_shortcode_link', 'wpb_wps_advance_settings', 'on' );

		$slider_title = get_post_meta( $id, 'wpb_wps_title', true );
		$slider_title = $slider_title ? 'title="'.$slider_title.'"' : '';

		$posts = get_post_meta( $id, 'wpb_wps_posts', true );
		$posts = $posts ? 'posts="'.$posts.'"' : '';

		$theme = get_post_meta( $id, 'wpb_wps_theme', true );
		$theme = $theme ? 'theme="'.$theme.'"' : '';

		$nav = get_post_meta( $id, 'wpb_wps_nav', true );
		$nav = $nav == 'on' ? 'nav="true"' : 'nav="false"';

		$pagination = get_post_meta( $id, 'wpb_wps_pagination', true );
		$pagination = $pagination == 'on' ? 'pagination="true"' : 'pagination="false"';

		$autoplay = get_post_meta( $id, 'wpb_wps_autoplay', true );
		$autoplay_speed = get_post_meta( $id, 'wpb_wps_autoplay_speed', true );
		$autoplay = $autoplay == 'on' ? 'autoplay="'.$autoplay_speed.'"' : 'autoplay="false"';

		$items = get_post_meta( $id, 'wpb_wps_items', true );
		$items = $items ? 'items="'.$items.'"' : '';

		$items_desktop = get_post_meta( $id, 'wpb_wps_items_desktop', true );
		$items_desktop = $items_desktop ? 'items_desktop="'.$items_desktop.'"' : '';

		$items_desktop_small = get_post_meta( $id, 'wpb_wps_items_desktop_small', true );
		$items_desktop_small = $items_desktop_small ? 'items_desktop_small="'.$items_desktop_small.'"' : '';

		$items_tablet = get_post_meta( $id, 'wpb_wps_items_tablet', true );
		$items_tablet = $items_tablet ? 'items_tablet="'.$items_tablet.'"' : '';

		$items_mobile = get_post_meta( $id, 'wpb_wps_items_mobile', true );
		$items_mobile = $items_mobile ? 'items_mobile="'.$items_mobile.'"' : '';

		$width = get_post_meta( $id, 'wpb_wps_width', true );
		$width = $width ? 'width="'.$width.'"' : '';

		$height = get_post_meta( $id, 'wpb_wps_height', true );
		$height = $height ? 'height="'.$height.'"' : '';

		$crop = get_post_meta( $id, 'wpb_wps_crop', true );
		$crop = $crop ? 'crop="true"' : 'crop="false"';

		$product_type = get_post_meta( $id, 'wpb_wps_product_type', true );
		$final_product_type = $product_type ? 'product_type="'.$product_type.'"' : '';

		$skus = get_post_meta( $id, 'wpb_wps_skus', false );
		$skus = !empty($skus) ? implode (",", $skus[0]) : '';
		$skus = $skus && $product_type == 'skus' ? 'skus="'.$skus.'"' : '';

		$category = get_post_meta( $id, 'wpb_wps_category', true );
		$category = !empty($category) ? implode (",", $category) : '';
		$category = $category != '' ? 'category="'.$category.'"' : '';

		$exclude_category = get_post_meta( $id, 'wpb_wps_exclude_category', false );
		$exclude_category = !empty($exclude_category) ? implode (",", $exclude_category[0]) : '';
		$exclude_category = $exclude_category != '' ? 'exclude_category="'.$exclude_category.'"' : '';

		$tags = get_post_meta( $id, 'wpb_wps_tags', false );
		$tags = !empty($tags) ? implode (",", $tags[0]) : '';
		$tags = $tags && $product_type == 'tags' ? 'tags="'.$tags.'"' : '';

		$exclude_tags = get_post_meta( $id, 'wpb_wps_exclude_tags', false );
		$exclude_tags = !empty($exclude_tags) ? implode (",", $exclude_tags[0]) : '';
		$exclude_tags = $exclude_tags && $product_type == 'tags' ? 'exclude_tags="'.$exclude_tags.'"' : '';

		$product_ids = get_post_meta( $id, 'wpb_wps_product_ids', false );
		$product_ids = !empty($product_ids) ? implode (",", $product_ids[0]) : '';
		$product_ids = $product_ids && $product_type == 'id' ? 'id="'.$product_ids.'"' : '';

		$orderby = get_post_meta( $id, 'wpb_wps_orderby', true );
		$orderby = ( $product_type == 'best_selling' ? 'meta_value_num' : $orderby );
		$orderby = $orderby ? 'orderby="'.$orderby.'"' : '';

		$order = get_post_meta( $id, 'wpb_wps_order', true );
		$order = ( $product_type == 'best_selling' ? 'DESC' : $order );
		$order = $order ? 'order="'.$order.'"' : '';

		$attribute = get_post_meta( $id, 'wpb_wps_attribute', true );
		$attribute = $attribute && $product_type == 'attribute' ? 'attribute="'.$attribute.'"' : '';

		$filters = get_post_meta( $id, 'wpb_wps_filters', false );
		$filters = !empty($filters) ? implode (",", $filters[0]) : '';
		$filters = $filters && $product_type == 'attribute' ? 'filters="'.$filters.'"' : '';
		

	   	ob_start();

		echo do_shortcode( '[wpb-product-slider '.$posts.' '.$slider_title.' '.$theme.' '.$nav.' '.$autoplay.' '.$pagination.' '.$items.' '.$items_desktop.' '.$items_desktop_small.' '.$items_tablet.' '.$items_mobile.' '.$width.' '.$height.' '.$crop.' '.$final_product_type.' '.$skus.' '.$category.' '.$exclude_category.' '.$tags.' '.$exclude_tags.' '.$product_ids.' '.$orderby.' '.$order.' '.$attribute.' '.$filters.']' );

		if( $edit_shortcode_link == 'on' ){
			edit_post_link( __( 'Edit Shortcode', 'wpb-woocommerce-product-slider' ), '', '', $id, 'wpb-wps-shortcode-edit' );
		}

		return ob_get_clean();
		
		return $output;
	}
endif;




/**
 * Adding the dynamic shortcode to the shortcode post type column
 */

add_filter( 'manage_edit-wpb_wps_shortcode_columns', 'wpb_wps_edit_shortcode_post_type_columns' ) ;

function wpb_wps_edit_shortcode_post_type_columns( $columns ) {

	$columns = array(
		'cb' 		=> '<input type="checkbox" />',
		'title' 	=> __( 'Shortcode Name', 'wpb-woocommerce-product-slider' ),
		'shortcode' => __( 'Shortcode', 'wpb-woocommerce-product-slider' ),
		'date' 		=> __( 'Date', 'wpb-woocommerce-product-slider' ),
	);

	return $columns;
}



add_action( 'manage_wpb_wps_shortcode_posts_custom_column', 'wpb_wps_manage_shortcode_post_type_columns', 10, 2 );

function wpb_wps_manage_shortcode_post_type_columns( $column, $post_id ) {
	global $post;

	switch( $column ) {

		/* If displaying the 'shortcode' column. */
		case 'shortcode' :

			/* Get the post meta. */
			$shortcode = get_post_meta( $post_id, 'wpb_wps_shortcode', true );

			/* If no shortcode is found, output a default message. */
			if ( empty( $shortcode ) )
				echo __( 'No Shortcode found.', 'wpb-woocommerce-product-slider' );

			/* If there is a shortcode, append 'minutes' to the text string. */
			else

				printf( __( '<input type="text" name="wps_wps_shortcode_'. $post_id .'" id="wps_wps_shortcode_'. $post_id .'" value="%s" class="regular-text the-shortcode" size="30" readonly="readonly"/><a class="button shortcode_copy_button" data-copytarget="#wps_wps_shortcode_'. $post_id .'">Copy Shortcode</a>', 'wpb-woocommerce-product-slider' ), esc_attr($shortcode) );

			break;

		/* Just break out of the switch statement for everything else. */
		default :
			break;
	}
}
