<?php

/*
	WPB Woocommerce Product Slider pro 
	By WPBean
	
*/

if ( ! defined( 'ABSPATH' ) ) exit; // Exit if accessed directly 

// register shortcode for latest product 

function wpb_wps_shortcode($atts){
	extract(shortcode_atts( array(

		'title' 				=> '', // Slider title
		'theme' 				=> 'grid cs-style-3', // theme [ Options:  grid cs-style-3, ben-box, fashion, black, jupiter, mars]
		'nav'					=> 'true', // show navigation 
		'prev' 					=> "<i class='fa fa-angle-left'></i>", // prev icon
		'next' 					=> "<i class='fa fa-angle-right'></i>", // next icon
		'autoplay'				=> 'true', // slider auto play
		'stop'					=> 'true', // slider stop on mouse hover
		'pagination' 			=> 'false', // slider pagination
		'count' 				=> 'false', // slider pagination counting
		'items' 				=> 4, // Number of product on default screen
		'items_desktop'			=> 3, // Number of product on screen size 1199px
		'items_desktop_small'	=> 3, // Number of product on screen size 979px
		'items_tablet'			=> 2, // Number of product on screen size 768px
		'items_mobile'			=> 1, // Number of product on screen size 479px
		'singleitem'			=> 'false',
		'speed'					=> wpb_wps_get_option( 'wpb_wps_slider_speed', 'wpb_wps_slider_settings', 500 ),
		'pagination_speed'		=> wpb_wps_get_option( 'wpb_wps_slider_pagination_speed', 'wpb_wps_slider_settings', 1000 ),
		'width' 				=> '320', // Product image width
		'height' 				=> '300', // Product image height
		'crop' 					=> 'true', // Product image hard crop
		'product_type' 			=> 'latest', // latest, featured, category, tags, id, skus, on_sell, attribute, best_selling
		'skus'					=> '', // product skus comma separated
		'category'				=> '', // comma separated categories id
		'exclude_category'		=> '', // comma separated categories id
		'tags'					=> '', // comma separated tags id
		'exclude_tags'			=> '', // comma separated tags id
		'id'					=> '',
		'orderby'				=> 'none', // product orderby
		'order'					=> '', // product order
		'posts'					=> 10, // Number of products
		'attribute' 			=> '', // Products attributes
		'filters'     			=> '', // Products attributes filters, multiple filters by comma separated.
		'show_reviews'     		=> wpb_wps_get_option( 'wpb_wps_show_reviews', 'wpb_wps_general', 'off' ),
		'show_category'     	=> wpb_wps_get_option( 'wpb_wps_show_category', 'wpb_wps_general', 'on' ),
		'show_price'     		=> wpb_wps_get_option( 'wpb_wps_show_price', 'wpb_wps_general', 'on' ),
		'show_title'     		=> wpb_wps_get_option( 'wpb_wps_show_title', 'wpb_wps_general', 'on' ),
		'show_cart'     		=> wpb_wps_get_option( 'wpb_wps_show_cart', 'wpb_wps_general', 'on' ),
		'show_availability'     => wpb_wps_get_option( 'show_availability', 'wpb_wps_general', 'on' ),
		'mouse_drag'     		=> wpb_wps_get_option( 'wpb_wps_mouse_drag', 'wpb_wps_slider_settings', 'on' ),
		'touch_drag'     		=> wpb_wps_get_option( 'wpb_wps_touch_drag', 'wpb_wps_slider_settings', 'on' ),
		'auto_crop_images'     	=> wpb_wps_get_option( 'wpb_wps_auto_crop_images', 'wpb_wps_slider_settings', 'on' ),
		'show_ribon'     		=> wpb_wps_get_option( 'wpb_wps_show_ribon', 'wpb_wps_general', 'on' ),
		'product_title_limit'   => wpb_wps_get_option( 'wpb_wps_product_title_limit', 'wpb_wps_general', 'off' ),
		'scroll_per_page'   	=> wpb_wps_get_option( 'wpb_wps_scroll_per_page', 'wpb_wps_slider_settings', 'off' ),

	), $atts ) );

	if( $product_type == 'best_selling' ){
		$orderby = 'meta_value_num';
		$order 	 = 'DESC';
	}

	$products_id = ( $id ? explode( ',', $id ) : null );

    $args = array(
		'post_type' 		=> 'product',
		'posts_per_page'	=> $posts,
		'post__in' 			=> $products_id,
		'orderby' 			=> $orderby,
		'order' 			=> $order,
	);
	

	// Woo meta featured post check 
	if($product_type == 'featured'){
		$args['meta_query'][] = array(
			'key' 		=> '_featured',
			'value' 	=> 'yes',
		);
	}

	// only selected categories
	if( $category && $category != '' ){
		$category = explode(',', $category);
		$args['tax_query'][] = array(
			'taxonomy' 	=> 'product_cat',
	        'field'    	=> 'id',
			'terms'    	=> $category,
	        'operator' 	=> 'IN' 
		);
	}

	// Exclude selected categories
	if( $exclude_category && $exclude_category != '' ){
		$exclude_category = explode(',', $exclude_category);
		$args['tax_query'][] = array(
			'taxonomy' 	=> 'product_cat',
	        'field'    	=> 'id',
			'terms'    	=> $exclude_category,
	        'operator' 	=> 'NOT IN' 
		);
	}

	// only selected tags
	if( $tags && $tags != '' ){
		$tags = explode(',', $tags);
		$args['tax_query'][] = array(
			'taxonomy' 	=> 'product_tag',
	        'field'    	=> 'id',
			'terms'    	=> $tags,
	        'operator' 	=> 'IN' 
		);
	}

	// Exclude selected tags
	if( $exclude_tags && $exclude_tags != '' ){
		$exclude_tags = explode(',', $exclude_tags);
		$args['tax_query'][] = array(
			'taxonomy' 	=> 'product_tag',
	        'field'    	=> 'id',
			'terms'    	=> $exclude_tags,
	        'operator' 	=> 'NOT IN' 
		);
	}
	
	// Woo meta sku check 
	if ( isset( $atts['skus'] ) ) {
		$skus = explode( ',', $atts['skus'] );
		$skus = array_map( 'trim', $skus );
		$args['meta_query'][] = array(
			'key' 		=> '_sku',
			'value' 	=> $skus,
			'compare' 	=> 'IN'
		);
	}

	// On Sell Products
	if( $product_type == 'on_sell' ) {

		$args['meta_query'][] = array(
	        'relation' => 'OR',
	        array( // Simple products type
	            'key'           => '_sale_price',
	            'value'         => 0,
	            'compare'       => '>',
	            'type'          => 'numeric'
	        ),
	        array( // Variable products type
	            'key'           => '_min_variation_sale_price',
	            'value'         => 0,
	            'compare'       => '>',
	            'type'          => 'numeric'
	        )
	    );
	}

	//Best selling products
	if($product_type == 'best_selling'){
		$args['meta_query'][] = array(
			'key'       => 'total_sales',
		);
	}

	// Out of stock Products
	$wpb_wps_show_out_of_stock = wpb_wps_get_option( 'wpb_wps_show_out_of_stock', 'wpb_wps_general', 'off' );
	if( $wpb_wps_show_out_of_stock == 'off' ){
		$args['meta_query'][] = array(
			'key'       => '_stock_status',
			'value'     => 'outofstock',
			'compare'   => 'NOT IN'
		);
	}

	// Product attribute
	if ( $attribute && $attribute != '' ) {
		$args['tax_query'][] = array(
			'taxonomy' 		=> strstr( $attribute, 'pa_' ) ? sanitize_title( $attribute ) : 'pa_' . sanitize_title( $attribute ),
			'terms' 		=> array_map( 'sanitize_title', explode( ',', $filters ) ),
			'field' 		=> 'slug',
			'operator' 		=> 'IN'
		);
	}

	$has_title_class 	= ( $title && $title != '' ? 'wpb_slider_has_title' : 'wpb_slider_no_title' );
	if ( empty($autoplay) ) {
    	$autoplay = 'true';
    }

    $slider_data_attr = array(
    	'autoplay'			=> $autoplay,
    	'stoponhover'		=> $stop,
    	'navigation'		=> $nav,
    	'navtextleft'		=> $prev,
    	'navtextright'		=> $next,
    	'slidespeed'		=> $speed,
    	'paginationspeed'	=> $pagination_speed,
    	'pagination'		=> $pagination,
    	'paginationnumbers'	=> $count,
    	'items'				=> $items,
    	'itemsdesktop'		=> $items_desktop,
    	'desktopsmall'		=> $items_desktop_small,
    	'tablet'			=> $items_tablet,
    	'mobile'			=> $items_mobile,
    	'scrollperpage'		=> ( $scroll_per_page == 'on' ? 'true' : 'false' ),
    	'singleitem'		=> $singleitem,
    	'mousedrag'			=> ( $mouse_drag == 'on' ? 'true' : 'false' ),
    	'touchdrag'			=> ( $touch_drag == 'on' ? 'true' : 'false' ),
    	'direction'			=> ( is_rtl() ? 'rtl' : 'default' ),
    );
    $slider_data_attr = apply_filters( 'wpb_wps_data_attributes', $slider_data_attr );
					
	$loop = new WP_Query( $args );
	ob_start();
	?>

	<div class="wpb_slider_area wpb_fix_cart <?php echo $has_title_class; ?> theme-<?php echo $theme; ?><?php echo do_action( 'wpb_wps_wrapper_class' );?>">
		<?php echo ( $title ? '<h2 class="wpb_area_title">'.$title.'</h2>' : '' ); ?>
	    <div class="wpb_woo_slider owl-carousel <?php echo $theme; ?>" <?php wpb_wps_data_attributes( $slider_data_attr ); ?>>

		    <?php
				if ( $loop->have_posts() ) {
					while ( $loop->have_posts() ) : $loop->the_post();

						global $post, $woocommerce, $product;
						$price_html = $product->get_price_html();
						$pro_thumb = get_post_thumbnail_id();
						$pro_img_url = wp_get_attachment_url( $pro_thumb,'full' ); //get full URL
						$pro_image = wpb_wps_aq_resize( $pro_img_url, $width, $height, $crop ); //resize & crop the image
						$pro_alt_text = htmlspecialchars( get_post_meta($pro_thumb , '_wp_attachment_image_alt', true) ); // image alt text
						?>

				        <div class="item <?php echo implode( get_post_class()," " ); ?>">
							<?php
						        if ( $product->is_on_sale() &&  $show_ribon == 'on' ) {
						        	echo apply_filters( 'woocommerce_sale_flash', '<span class="onsale">' . __( 'Sale!', 'wpb-woocommerce-product-slider' ) . '</span>', $post, $product	 );
						        }

						        // Availability
								$availability = $product->get_availability();
								if ( $availability['availability'] && $show_availability == 'on' ) :
									echo apply_filters( 'woocommerce_stock_html', '<div class="stock ' . esc_attr( $availability['class'] ) . '">' . esc_html( $availability['availability'] ) . '</div>', $availability['availability'] );
								endif;
					        ?>
							<figure>
								<a href="<?php echo get_permalink(); ?>" class="wpb_pro_img_url">
									<?php
										if( $auto_crop_images == 'on' && $pro_image ){
											if (has_post_thumbnail( $loop->post->ID )){
												echo '<img src="'.$pro_image.'" alt="'.$pro_alt_text.'" class="wpb_pro_img" />';
											}else{
												echo '<img class="wpb_pro_img" src="'. apply_filters( 'wpb_wps_placeholder_img_src', 'http://placehold.it/'.$width.'x'.$height.'' ) .'" alt="Placeholder" />';
											}
											
										}else {
											echo woocommerce_get_product_thumbnail();
										}
									?>
								</a>

								<?php 
									if( $show_cart && $show_cart == 'on' && in_array( $theme, array( 'mars' ) ) ){
										wpb_wps_cart_button();
									}
								?>

								<figcaption>
									<?php
										if( in_array( $theme, array( 'grid cs-style-3', 'ben-box', 'fashion' ) ) ):

											if( $show_category && $show_category == 'on' && $theme == 'ben-box'){
												echo '<span class="wpb_pro_cat">'.get_the_term_list(get_the_id(), 'product_cat', '', ',&nbsp;').'</span>';
											}

											if( $show_title && $show_title == 'on'){
												echo '<h3 class="wpb_product_title"><a href="'.get_permalink().'">';
												if ( strlen($post->post_title) > 20 && $product_title_limit == 'on' ) {
													echo substr(the_title($before = '', $after = '', FALSE), 0, wpb_wps_get_option( 'wpb_title_mx_ch', 'wpb_wps_general', 10 )) . '...';
												}else{
													echo get_the_title();
												}
												echo '</a></h3>';
											}

											if( $price_html &&  $show_price == 'on' ){
												echo '<span class="price wpb_wps_product_price">'. $price_html .'</span>';
											}

											if ( $woocommerce->version >= '3.0' ){
												if ( wc_get_rating_html( $product->get_average_rating() ) && get_option( 'woocommerce_enable_review_rating' ) === 'yes' && $show_reviews == 'on' ){
													echo wc_get_rating_html( $product->get_average_rating() );
												}
											}else{
												if ( $product->get_rating_html() && get_option( 'woocommerce_enable_review_rating' ) === 'yes' && $show_reviews == 'on' ){
													echo $product->get_rating_html();
												}
											}

										endif;

										if( $show_cart && $show_cart == 'on' && !in_array( $theme, array( 'mars' ) ) ){
											wpb_wps_cart_button();
										}
									?>

									<?php if( in_array( $theme, array( 'black', 'ben-box', 'fashion', 'jupiter', 'mars' ) ) ): ?>
										<div class="wpb-wps-quickview-wishlist-compare wpb-wps-button-group">
											<?php 
												if( function_exists( 'get_wpb_woocommerce_lightbox' ) && in_array( $theme, array( 'ben-box', 'fashion', 'jupiter', 'mars' ) ) ){
													get_wpb_woocommerce_lightbox( $post->ID );
												}
											?>
											<?php
												if( class_exists( 'YITH_WCQV_Frontend' ) && in_array( $theme, array( 'ben-box', 'fashion', 'jupiter', 'mars' ) ) ) {
													$yith_quickview = new YITH_WCQV_Frontend();
													echo '<div class="wpb-yith-wcqv-button">';
													echo $yith_quickview->yith_add_quick_view_button();
													echo '</div>';
												}
											?>
											<?php 
												if ( in_array( 'yith-woocommerce-compare/init.php', apply_filters( 'active_plugins', get_option( 'active_plugins' ) ) ) && in_array( $theme, array( 'ben-box', 'fashion' ) ) ) {
												    echo do_shortcode('[yith_compare_button]<i class="fa fa-exchange" aria-hidden="true"></i>[/yith_compare_button]');
												}
											?>
											<?php 
												if ( in_array( 'yith-woocommerce-wishlist/init.php', apply_filters( 'active_plugins', get_option( 'active_plugins' ) ) ) && in_array( $theme, array( 'ben-box', 'fashion', 'black', 'jupiter', 'mars' ) )) {
												    echo do_shortcode('[yith_wcwl_add_to_wishlist]');
												}
											?>
										</div>
									<?php endif;?>

									<?php echo do_action( 'wpb_wps_after_slider_loop_item' ) ?>

								</figcaption>
							</figure>
							<?php
								if( in_array( $theme, array( 'black', 'jupiter', 'mars' ) ) ):
									echo '<div class="wpb_wps_slider_caption">';

									if( $show_title && $show_title == 'on'){
										echo '<h3 class="wpb_product_title"><a href="'.get_permalink().'">';
										if ( strlen($post->post_title) > 20 && $product_title_limit == 'on' ) {
											echo substr(the_title($before = '', $after = '', FALSE), 0, wpb_wps_get_option( 'wpb_title_mx_ch', 'wpb_wps_general', 10 )) . '...';
										}else{
											echo get_the_title();
										}
										echo '</a></h3>';
									}

									if ( $woocommerce->version >= '3.0' ){
										if ( wc_get_rating_html( $product->get_average_rating() ) && get_option( 'woocommerce_enable_review_rating' ) === 'yes' && $show_reviews == 'on' ){
											echo wc_get_rating_html( $product->get_average_rating() );
										}
									}else{
										if ( $product->get_rating_html() && get_option( 'woocommerce_enable_review_rating' ) === 'yes' && $show_reviews == 'on' ){
											echo $product->get_rating_html();
										}
									}

									if( $price_html &&  $show_price == 'on' ){
										echo '<span class="price wpb_wps_product_price">'. $price_html .'</span>';
									}

									echo '</div>';
								endif;
							?>
						</div>
				 		<?php
					endwhile;
					wp_reset_postdata();
				} else {
					echo __( 'No products found', 'wpb-woocommerce-product-slider' );
				}
			?>
	    </div>
	</div>

	<?php
	wp_reset_query();
  	return ob_get_clean();
}

add_shortcode('wpb-product-slider', 'wpb_wps_shortcode');