<?php

/*
	WPB Woocommerce Product Slider pro 
	By WPBean
	
*/

if ( ! defined( 'ABSPATH' ) ) exit; 


/**
 * Woocommerce not installed error message
 */

function wpb_wps_admin_notice() {
    ?>
    <div class="error"><p><?php _e( '<strong>WPB WooCommerce Product Slider</strong> plugin need <strong>WooCommerce</strong> plugin installed. Please install &amp; active the <strong>WooCommerce</strong> plugin.', 'wpb-woocommerce-product-slider' ); ?></p></div>
    <?php
}


/**
 * Check if WooCommerce is active
 */

if ( !in_array( 'woocommerce/woocommerce.php', apply_filters( 'active_plugins', get_option( 'active_plugins' ) ) ) ) {
   add_action( 'admin_notices', 'wpb_wps_admin_notice' );
}


/**
 * Widget shortcode support
 */

add_filter('widget_text', 'do_shortcode');



/**
 * Getting ready the plugin settings 
 */


function wpb_wps_get_option( $option, $section, $default = '' ) {
 
    $options = get_option( $section );
 
    if ( isset( $options[$option] ) ) {
        return $options[$option];
    }
 
    return $default;
}



/**
 * Custom styles
 */

add_action('wp_enqueue_scripts','wpb_wps_custom_style');

function wpb_wps_custom_style(){

	wp_enqueue_style( 'wpb_wps_main_style', plugins_url('../css/main.css', __FILE__), '', '1.0', false);
	$settings_custom_css = wpb_wps_get_option( 'wpb_wps_custom_css', 'wpb_wps_style_settings', '' );
	ob_start();
	?>

	/* Ben Box */
	.wpb_slider_area .ben-box .item {
		border-color: <?php echo wpb_wps_get_option( 'wpb_item_border_color', 'ben_box', '#ccc' );?>;
	}
	.wpb_slider_area .ben-box .item:hover {
		border-color: <?php echo wpb_wps_get_option( 'wpb_item_border_color_hover', 'ben_box', '#f65b47' );?>;
	}
	.ben-box figcaption h3.wpb_product_title a {
		color: <?php echo wpb_wps_get_option( 'wpb_title_color', 'ben_box', '#111' );?>
	}
	.ben-box figcaption h3.wpb_product_title a:hover {
		color: <?php echo wpb_wps_get_option( 'wpb_title_color_hover', 'ben_box', '#f65b47' );?>
	}
	.wpb_slider_area.theme-ben-box .wpb_wps_product_price {
		color: <?php echo wpb_wps_get_option( 'wpb_price_color', 'ben_box', '#f65b47' );?>
	}
	.wpb_woo_slider.ben-box .wpb_cart_button a.button {
		color: <?php echo wpb_wps_get_option( 'wpb_cart_btn_color', 'ben_box', '#b3abab' );?>!important;
		border-color: <?php echo wpb_wps_get_option( 'wpb_cart_btn_border', 'ben_box', '#b3abab' );?>;
		<?php if( wpb_wps_get_option( 'wpb_cart_btn_bg', 'ben_box' ) ):?>
		background-color: <?php echo wpb_wps_get_option( 'wpb_cart_btn_bg', 'ben_box', 'transparent' );?>;
		<?php endif;?>
	}
	.wpb_woo_slider.ben-box .wpb_cart_button a.button:hover {
		color: <?php echo wpb_wps_get_option( 'wpb_cart_btn_color_hover', 'ben_box', '#f65b47' );?>!important;
		border-color: <?php echo wpb_wps_get_option( 'wpb_cart_btn_border_hover', 'ben_box', '#f65b47' );?>;
		<?php if( wpb_wps_get_option( 'wpb_cart_btn_bg_hover', 'ben_box' ) ):?>
		background-color: <?php echo wpb_wps_get_option( 'wpb_cart_btn_bg_hover', 'ben_box', 'transparent' );?>;
		<?php endif;?>
	}
	<?php if( wpb_wps_get_option( 'wpb_add_btn_color', 'ben_box' ) ):?>
	.wpb_woo_slider.ben-box .wpb-wps-button-group a {
		color: <?php echo wpb_wps_get_option( 'wpb_add_btn_color', 'ben_box' );?>;
	}
	<?php endif;?>
	.wpb_woo_slider.ben-box span.onsale, 
	.woocommerce .wpb_woo_slider.ben-box span.onsale,
	.wpb_slider_area.theme-ben-box .wpb_woo_slider div.stock,
    .woocommerce .wpb_slider_area.theme-ben-box .wpb_woo_slider div.stock {
		background-color: <?php echo wpb_wps_get_option( 'wpb_onsale_bg', 'ben_box', '#f65b47' );?>;
	}

	/* Hover */
	.wpb_slider_area .grid figcaption {
		background-color: <?php echo wpb_wps_get_option( 'wpb_overlay_color', 'hover', 'rgba(0,0,0,0.5)' );?>;
	}
	.wpb_slider_area .grid figcaption h3 a {
		color: <?php echo wpb_wps_get_option( 'wpb_title_color', 'hover', '#fff' );?>!important;
	}
	.wpb_slider_area .grid figcaption h3 a:hover {
		color: <?php echo wpb_wps_get_option( 'wpb_title_color_hover', 'hover', '#f65b47' );?>!important;
	}
	.wpb_slider_area.theme-grid .wpb_wps_product_price {
		color: <?php echo wpb_wps_get_option( 'wpb_price_color', 'hover', '#f65b47' );?>
	}
	.wpb_woo_slider.grid .wpb_cart_button a.button {
		color: <?php echo wpb_wps_get_option( 'wpb_cart_btn_color', 'hover', '#fff' );?>!important;
		border-color: <?php echo wpb_wps_get_option( 'wpb_cart_btn_border', 'hover', '#fff' );?>!important;
		<?php if( wpb_wps_get_option( 'wpb_cart_btn_bg', 'hover' ) ):?>
		background-color: <?php echo wpb_wps_get_option( 'wpb_cart_btn_bg', 'hover', 'transparent' );?>;
		<?php endif;?>
	}
	.wpb_woo_slider.grid .wpb_cart_button a.button:hover {
		color: <?php echo wpb_wps_get_option( 'wpb_cart_btn_color_hover', 'hover', '#f65b47' );?>!important;
		border-color: <?php echo wpb_wps_get_option( 'wpb_cart_btn_border_hover', 'hover', '#f65b47' );?>!important;
		<?php if( wpb_wps_get_option( 'wpb_cart_btn_bg_hover', 'hover' ) ):?>
		background-color: <?php echo wpb_wps_get_option( 'wpb_cart_btn_bg_hover', 'hover', 'transparent' );?>;
		<?php endif;?>
	}
	.wpb_woo_slider.grid span.onsale, 
	.woocommerce .wpb_woo_slider.grid span.onsale,
	.wpb_slider_area.theme-grid .wpb_woo_slider div.stock,
	.woocommerce .wpb_slider_area.theme-grid .wpb_woo_slider div.stock {
		background-color: <?php echo wpb_wps_get_option( 'wpb_onsale_bg', 'hover', '#f65b47' );?>;
	}

	/* fashion theme */
	.wpb_slider_area .fashion figcaption h3 a {
		color: <?php echo wpb_wps_get_option( 'wpb_title_color', 'fashion', '#9f9f9f' );?>;
	}
	<?php if( wpb_wps_get_option( 'wpb_title_color_hover', 'fashion' ) ):?>
	.wpb_slider_area .fashion figcaption h3 a:hover {
		color: <?php echo wpb_wps_get_option( 'wpb_title_color_hover', 'fashion' );?>;
	}
	<?php endif;?>
	.wpb_slider_area.theme-fashion .wpb_wps_product_price {
		color: <?php echo wpb_wps_get_option( 'wpb_price_color', 'fashion', '#3e7cb4' );?>
	}
	.wpb_woo_slider.fashion .wpb_cart_button a.button {
		color: <?php echo wpb_wps_get_option( 'wpb_cart_btn_color', 'fashion', '#fff' );?>!important;
		background-color: <?php echo wpb_wps_get_option( 'wpb_cart_btn_bg', 'fashion', '#3e7cb4' );?>!important;
	}
	.wpb_woo_slider.fashion .wpb_cart_button a.button:hover {
		color: <?php echo wpb_wps_get_option( 'wpb_cart_btn_color_hover', 'fashion', '#fff' );?>;
		background-color: <?php echo wpb_wps_get_option( 'wpb_cart_btn_bg_hover', 'fashion', '#444' );?>;
	}
	<?php if( wpb_wps_get_option( 'wpb_add_btn_color', 'fashion' ) ):?>
	.wpb_woo_slider.fashion .wpb-wps-button-group a {
		color: <?php echo wpb_wps_get_option( 'wpb_add_btn_color', 'fashion' );?>;
	}
	<?php endif;?>
	.wpb_woo_slider.fashion span.onsale, 
	.woocommerce .wpb_woo_slider.fashion span.onsale,
	.wpb_slider_area.theme-fashion .wpb_woo_slider div.stock,
	.woocommerce .wpb_slider_area.theme-fashion .wpb_woo_slider div.stock {
		background-color: <?php echo wpb_wps_get_option( 'wpb_onsale_bg', 'fashion', '#3e7cb4' );?>;
	}

	/* black */
	.wpb_slider_area .black .wpb_wps_slider_caption h3 a {
		color: <?php echo wpb_wps_get_option( 'wpb_title_color', 'black', '#252525' );?>;
	}
	.wpb_slider_area .black .wpb_wps_slider_caption h3 a:hover {
		color: <?php echo wpb_wps_get_option( 'wpb_title_color_hover', 'black', '#EA2C58' );?>;
	}
	.wpb_slider_area.theme-black .wpb_wps_product_price {
		color: <?php echo wpb_wps_get_option( 'wpb_price_color', 'black', '#4a4a4a' );?>
	}
	.wpb_slider_area.theme-black  .wpb_woo_slider .star-rating span {
		color: <?php echo wpb_wps_get_option( 'wpb_rating', 'black', '#EA2C58' );?>;
	}
	.wpb_woo_slider.black .wpb_cart_button a.button {
		color: <?php echo wpb_wps_get_option( 'wpb_cart_btn_color', 'black', '#fff' );?>;
		background: <?php echo wpb_wps_get_option( 'wpb_cart_btn_bg', 'black', '#252525' );?>;
	}
	.wpb_woo_slider.black .wpb_cart_button a.button:hover {
		color: <?php echo wpb_wps_get_option( 'wpb_cart_btn_color_hover', 'black', '#fff' );?>;
		background: <?php echo wpb_wps_get_option( 'wpb_cart_btn_bg_hover', 'black', '#EA2C58' );?>;
	}
	.wpb_slider_area.theme-black figcaption > .wpb-wps-button-group a {
		color: <?php echo wpb_wps_get_option( 'wpb_wishlist_btn_color', 'black', '#fff' );?>;
		background: <?php echo wpb_wps_get_option( 'wpb_wishlist_btn_bg', 'black', '#EA2C58' );?>;
	}
	.wpb_slider_area.theme-black figcaption > .wpb-wps-button-group a:hover {
		color: <?php echo wpb_wps_get_option( 'wpb_wishlist_btn_color_hover', 'black', '#fff' );?>;
		background: <?php echo wpb_wps_get_option( 'wpb_wishlist_btn_bg_hover', 'black', '#666666' );?>;
	}
	.wpb_woo_slider.black span.onsale, 
	.woocommerce .wpb_woo_slider.black span.onsale,
	.wpb_slider_area.theme-black .wpb_woo_slider div.stock, 
	.woocommerce .wpb_slider_area.theme-black .wpb_woo_slider div.stock {
		background-color: <?php echo wpb_wps_get_option( 'wpb_onsale_bg', 'black', '#EA2C58' );?>;
	}

	/* jupiter */
	.wpb_slider_area .jupiter .wpb_wps_slider_caption h3 a {
		color: <?php echo wpb_wps_get_option( 'wpb_title_color', 'jupiter', '#252525' );?>;
	}
	<?php if( wpb_wps_get_option( 'wpb_title_color_hover', 'jupiter' ) ):?>
	.wpb_slider_area .jupiter .wpb_wps_slider_caption h3 a:hover {
		color: <?php echo wpb_wps_get_option( 'wpb_title_color_hover', 'jupiter' );?>;
	}
	<?php endif;?>
	.wpb_slider_area.theme-jupiter .wpb_wps_product_price {
		color: <?php echo wpb_wps_get_option( 'wpb_price_color', 'jupiter', '#4a4a4a' );?>
	}
	.wpb_slider_area.theme-jupiter  .wpb_woo_slider .star-rating span {
		color: <?php echo wpb_wps_get_option( 'wpb_rating', 'jupiter', '#EA2C58' );?>;
	}
	.wpb_woo_slider.jupiter .wpb_cart_button a.button,
	.wpb_slider_area.theme-jupiter figcaption > .wpb-wps-button-group a, 
	.wpb_slider_area.theme-jupiter .wpb-wps-button-group .wpb_wl_btn_auto_off a.wpb_wl_preview, 
	.wpb_slider_area.theme-jupiter .wpb_woo_slider figcaption a.yith-wcqv-button.button {
		color: <?php echo wpb_wps_get_option( 'wpb_add_btn_color', 'jupiter', '#fff' );?>;
		background: <?php echo wpb_wps_get_option( 'wpb_add_btn_bg', 'jupiter', '#252525' );?>;
	}
	.wpb_woo_slider.jupiter .wpb_cart_button a.button:hover,
	.wpb_slider_area.theme-jupiter figcaption > .wpb-wps-button-group a:hover, 
	.wpb_slider_area.theme-jupiter .wpb-wps-button-group .wpb_wl_btn_auto_off a.wpb_wl_preview:hover, 
	.wpb_slider_area.theme-jupiter .wpb_woo_slider figcaption a.yith-wcqv-button.button:hover {
		color: <?php echo wpb_wps_get_option( 'wpb_add_btn_color_hover', 'jupiter', '#fff' );?>;
		background: <?php echo wpb_wps_get_option( 'wpb_add_btn_bg_hover', 'jupiter', '#EA2C58' );?>;
	}
	.wpb_woo_slider.jupiter span.onsale, 
	.woocommerce .wpb_woo_slider.jupiter span.onsale,
	.wpb_slider_area.theme-jupiter .wpb_woo_slider div.stock,
	.woocommerce .wpb_slider_area.theme-jupiter .wpb_woo_slider div.stock {
		background-color: <?php echo wpb_wps_get_option( 'wpb_onsale_bg', 'jupiter', '#666' );?>;
	}

	/* mars */
	.wpb_slider_area.theme-mars figure > a.wpb_pro_img_url:before {
		background-color: <?php echo wpb_wps_get_option( 'wpb_overlay_color', 'mars', 'rgba(51,51,51,.3)' );?>;
	}
	.wpb_woo_slider.mars .wpb_cart_button a.button {
		color: <?php echo wpb_wps_get_option( 'wpb_cart_btn_color', 'mars', '#333' );?>;
		background: <?php echo wpb_wps_get_option( 'wpb_cart_btn_bg', 'mars', '#fff' );?>;
	}
	.wpb_woo_slider.mars .wpb_cart_button a.button:hover {
		color: <?php echo wpb_wps_get_option( 'wpb_cart_btn_color_hover', 'mars', '#fff' );?>;
		background: <?php echo wpb_wps_get_option( 'wpb_cart_btn_bg_hover', 'mars', '#333' );?>;
	}
	.wpb_slider_area.theme-mars figcaption > .wpb-wps-button-group a, 
	.wpb_slider_area.theme-mars .wpb-wps-button-group .wpb_wl_btn_auto_off a.wpb_wl_preview, 
	.wpb_slider_area.theme-mars .wpb_woo_slider figcaption a.yith-wcqv-button.button {
		color: <?php echo wpb_wps_get_option( 'wpb_add_btn_color', 'mars', '#fff' );?>;
		background: <?php echo wpb_wps_get_option( 'wpb_add_btn_bg', 'mars', '#333' );?>;
	}
	.wpb_slider_area.theme-mars figcaption > .wpb-wps-button-group a:hover, 
	.wpb_slider_area.theme-mars .wpb-wps-button-group .wpb_wl_btn_auto_off a.wpb_wl_preview:hover, 
	.wpb_slider_area.theme-mars .wpb_woo_slider figcaption a.yith-wcqv-button.button:hover {
		color: <?php echo wpb_wps_get_option( 'wpb_add_btn_color_hover', 'mars', '#fff' );?>;
		background: <?php echo wpb_wps_get_option( 'wpb_add_btn_bg_hover', 'mars', '#666' );?>;
	}
	.wpb_woo_slider.mars span.onsale, .woocommerce .wpb_woo_slider.mars span.onsale {
		background-color: <?php echo wpb_wps_get_option( 'wpb_onsale_bg', 'mars', '#333' );?>;
	}


	/* Rating */
	.wpb_woo_slider .star-rating span {
	    color: <?php echo wpb_wps_get_option( 'wpb_wps_rating_color', 'wpb_wps_style_settings', '#f7a308' );?>;
	}
	.wpb_slider_area .owl-theme .owl-controls .owl-page.active span,
	.wpb_slider_area .owl-theme .owl-controls .owl-buttons div:hover {
		background: <?php echo wpb_wps_get_option( 'wpb_wps_nav_pagi_color', 'wpb_wps_style_settings', '#cccccc' );?>!important;
	}
	.wpb_slider_area .owl-theme .owl-controls .owl-page span,
	.wpb_slider_area .owl-theme .owl-controls .owl-buttons div {
		border-color: <?php echo wpb_wps_get_option( 'wpb_wps_nav_pagi_color', 'wpb_wps_style_settings', '#cccccc' );?>!important;
	}
	.wpb_slider_area .owl-theme .owl-controls .owl-buttons div i {
	    color:<?php echo wpb_wps_get_option( 'wpb_wps_nav_pagi_color', 'wpb_wps_style_settings', '#cccccc' );?>!important;
	}

	<?php echo $settings_custom_css; ?>
	
	<?php
	$custom_css = ob_get_clean();

	wp_add_inline_style( 'wpb_wps_main_style', $custom_css );
}



/**
 * Getting ready the product category checkbox
 */
						

if ( ! function_exists('wpb_wps_product_categories_checkbox') ) {

	// Exclude selected categiry form portfolio.

	function wpb_wps_product_categories_checkbox(){
		$terms = array();
	    $terms = get_terms('product_cat');

	    foreach ( $terms as $term ) {
	        echo '<span class="wpb_wps_product_categories_area"><input type="checkbox" class="wpb_wps_product_categories" name="wpb_wps_product_categories" value="'.$term->slug.'">'.$term->name.'</span>';
	    }                                         
	      
	}

}



/**
 * Adding Conditiontal wrapper class
 */

add_action( 'wpb_wps_wrapper_class', 'wpb_wps_wrapper_add_class' );

if( !function_exists('wpb_wps_wrapper_add_class') ){
	function wpb_wps_wrapper_add_class(){

		$output = '';

		if( function_exists( 'get_wpb_woocommerce_lightbox' ) ){
			$output.= ' wpb_woocommerce_lightbox_enable';
		}

		if( class_exists( 'YITH_WCQV_Frontend' ) ){
			$output.= ' yith_quickview_enable';
		}

		if( class_exists( 'YITH_Woocompare' ) ){
			$output.= ' yith_compare_enable';
		}

		if( class_exists( 'YITH_WCWL' ) ){
			$output.= ' yith_wishlist_enable';
		}

		echo $output;
	}
}


/**
 * Cart Button
 */


if( !function_exists('wpb_wps_cart_button') ){
	function wpb_wps_cart_button(){
		global $post, $product;

		echo '<div class="wpb_cart_button">'. do_shortcode( '[add_to_cart id="'.$post->ID.'" style="" show_price="false"]' ) .'</div>'; 
	}
}

/**
 * Data attribute Array to data types
 */
if( !function_exists('wpb_wps_data_attributes') ){
	function wpb_wps_data_attributes($array){
		if( !empty($array) ){
			foreach ($array as $key => $value) {
				echo 'data-'.$key.'="'.$value.'" ';
			}
		}
	}
}
