<?php
/**
 * Plugin Name: 		WPB WooCommerce Product slider Pro
 * Plugin URI: 			https://wpbean.com/product/wpb-woocommerce-product-slider-pro/
 * Description: 		Number one WooCommerce product slider plugin.
 * Author: 				WpBean
 * Version: 			3.05.6
 * Author URI: 			http://wpbean.com
 * Text Domain:       	wpb-woocommerce-product-slider
 * Domain Path:       	/languages
*/

if ( ! defined( 'ABSPATH' ) ) exit; // Exit if accessed directly 


/**
 * WpBean Plugin updater init
 */

define( 'WPB_WPS_VERSION', '3.05.6' );
define( 'WPB_WPS_STORE_URL', 'https://wpbean.com' );
define( 'WPB_WPS_ITEM_NAME', 'WPB WooCommerce Product Slider PRO' );
define( 'WPB_WPS_PLUGIN_LICENSE_PAGE', 'wpb-woocommerce-product-slider-license' );


function wpb_wps_plugin_updater_init() {

	// retrieve our license key from the DB
	$license_key = trim( get_option( 'wpb_wps_license_key' ) );

	// setup the updater
	$edd_updater = new WpBean_Plugin_Updater( WPB_WPS_STORE_URL, __FILE__, array(
			'version'   => WPB_WPS_VERSION,
			'license'   => $license_key,
			'item_name' => WPB_WPS_ITEM_NAME,
			'author'    => 'WpBean',
			'url'       => home_url()
		)
	);

}
add_action( 'admin_init', 'wpb_wps_plugin_updater_init', 0 );


/**
 * Internationalization
 */

function wpb_wps_textdomain() {
	load_plugin_textdomain( 'wpb-woocommerce-product-slider', false, dirname( plugin_basename( __FILE__ ) ) . '/languages/' );
}
add_action( 'init', 'wpb_wps_textdomain' );



/**
 * Add plugin action links
 */

function wpb_wps_plugin_actions( $links ) {
	if( is_admin() ){
		$links[] = '<a href="http://wpbean.com/support/" target="_blank">'. __('Support','wpb-woocommerce-product-slider') .'</a>';
		$links[] = '<a href="options-general.php?page=wpb_woo_product_slider">'. __('Settings','wpb-woocommerce-product-slider') .'</a>';
	}
	return $links;
}
add_filter( 'plugin_action_links_' . plugin_basename(__FILE__), 'wpb_wps_plugin_actions' );


/**
 * Define metaboxes directory 
 */

if ( !defined( 'WPB_WPS_CUSTOM_METABOXES_DIR' ) ) {
	define( 'WPB_WPS_CUSTOM_METABOXES_DIR', plugins_url('/admin/metaboxes', __FILE__) );
}

/**
 * Required files
 */

require_once dirname( __FILE__ ) . '/inc/wpb-wps.php';
if( !function_exists('wpb_wps_aq_resize') && !class_exists('Aq_Resize') ){
	require_once dirname( __FILE__ ) . '/admin/wpb_resizer.php';
}
require_once dirname( __FILE__ ) . '/admin/wpb-wps-settings.php';
require_once dirname( __FILE__ ) . '/admin/wpb-wps-theme-customizer.php';
require_once dirname( __FILE__ ) . '/admin/wpb_wps_vc_map.php';
require_once dirname( __FILE__ ) . '/admin/wpb-wps-widgets.php';
require_once dirname( __FILE__ ) . '/inc/wpb-wps-shortcodes.php';
require_once dirname( __FILE__ ) . '/inc/wpb_wps_functions.php';

require_once dirname( __FILE__ ) . '/admin/metaboxes/meta_box.php';
require_once dirname( __FILE__ ) . '/admin/wpb_wps_shortcode_generator.php';

if( !class_exists( 'WpBean_Plugin_Updater' ) ) {
	include( dirname( __FILE__ ) . '/admin/updater/plugin-updater.php' );
}
require_once dirname( __FILE__ ) . '/admin/updater/updater-init.php';