<?php
/**
 * Adds Foo_Widget widget.
 */
class Foo_Widget extends WP_Widget {
	/**
	 * Register widget with WordPress.
	 */
	function __construct() {
		parent::__construct(
			'display_product_in_mega_menu_by_onliner', // Base ID
			esc_html__( 'نمایش محصولات با انتخاب دسته بندی', 'text_domain' ), // Name
			array( 'description' => esc_html__( 'نمایش محصولات با انتخاب دسته بندی', 'text_domain' ), ) // Args
		);
	}
	/**
	 * Front-end display of widget.
	 *
	 * @see WP_Widget::widget()
	 *
	 * @param array $args     Widget arguments.
	 * @param array $instance Saved values from database.
	 */
	public function widget( $args, $instance ) {
		echo $args['before_widget'];
?>
<?php
$tmp_query = $wp_query;
$wp_query = new WP_Query();
$wp_query->query(array( 
    'post_type' => 'product',   
    'posts_per_page' =>  $instance['num_post'],
	'tax_query' => array(
		array(
			'taxonomy' => 'product_cat',
			'terms'    => array($instance['category']),
		)
	)
));
if($wp_query->have_posts()):
while ($wp_query->have_posts()):
$wp_query->the_post(); ?>
                <div class="post_box_mega_menu">
                    <a href="<?php the_permalink(); ?>" title="<?php the_title(); ?>"><img
                            src="<?php if (has_post_thumbnail()) {
                                $img_id = get_post_thumbnail_id($post->ID);
                                $src = wp_get_attachment_image_src($img_id, 'shop_catalog');
                                echo $src[0];
                            } else if (ot_get_option('defult_img')) {
                                $image_id = get_image_id(ot_get_option('defult_img'));
                                $image_thumb = wp_get_attachment_image_src($image_id, 'shop_catalog');
                                echo $image_thumb[0];
                            } ?>" title="<?php the_title(); ?>" alt="<?php the_title(); ?>"/></a>
                    <h3><a href="<?php the_permalink(); ?>" title="<?php the_title(); ?>"><?php the_title(); ?></a></h3>
                </div>
		 <?php 
endwhile;
endif;
$wp_query = $tmp_query;
wp_reset_query();
		echo $args['after_widget'];
	}
	/**
	 * Back-end widget form.
	 *
	 * @see WP_Widget::form()
	 *
	 * @param array $instance Previously saved values from database.
	 */
	public function form( $instance ) {
		$title = $instance['title'];
		$category = $instance['category'];
		$num_post = ! empty( $instance['num_post'] ) ? $instance['num_post'] : 4;
		?>
		<p style="display:none">
		<label for="<?php echo esc_attr( $this->get_field_id( 'title' ) ); ?>"><?php esc_attr_e( 'Title:', 'text_domain' ); ?></label> 
		<input class="widefat" id="<?php echo esc_attr( $this->get_field_id( 'title' ) ); ?>" name="<?php echo esc_attr( $this->get_field_name( 'title' ) ); ?>" type="text" value="<?php echo esc_attr( $title ); ?>">
		</p>
		<p>
		<label for="<?php echo esc_attr( $this->get_field_id( 'category' ) ); ?>"><?php esc_attr_e( 'دسته بندی:', 'text_domain' ); ?></label> 
<?php $args = array(
	'show_option_all'    => '',
	'show_option_none'   => '',
	'option_none_value'  => '-1',
	'orderby'            => 'ID',
	'order'              => 'ASC',
	'show_count'         => 0,
	'hide_empty'         => 0,
	'child_of'           => 0,
	'exclude'            => '',
	'include'            => '',
	'echo'               => 1,
	'selected'           => $category,
	'hierarchical'       => 0,
	'name'               => esc_attr( $this->get_field_name( 'category' ) ),
	'id'                 => esc_attr( $this->get_field_name( 'category' ) ),
	'class'              => 'widefat',
	'depth'              => 0,
	'tab_index'          => 0,
	'taxonomy'           => 'product_cat',
	'hide_if_empty'      => false,
	'value_field'	     => 'term_id',
); ?>			
<?php wp_dropdown_categories( $args ); ?>
		</p>
		<p>
		<label for="<?php echo esc_attr( $this->get_field_id( 'num_post' ) ); ?>"><?php esc_attr_e( 'تعداد نمایش محصولات:', 'text_domain' ); ?></label> 
		<input class="widefat" id="<?php echo esc_attr( $this->get_field_id( 'num_post' ) ); ?>" name="<?php echo esc_attr( $this->get_field_name( 'num_post' ) ); ?>" type="text" value="<?php echo esc_attr( $num_post ); ?>">
		</p>
		<?php 
	}
	/**
	 * Sanitize widget form values as they are saved.
	 *
	 * @see WP_Widget::update()
	 *
	 * @param array $new_instance Values just sent to be saved.
	 * @param array $old_instance Previously saved values from database.
	 *
	 * @return array Updated safe values to be saved.
	 */
	public function update( $new_instance, $old_instance ) {
		$instance = array();
		$instance['title'] = $new_instance['title'];
		$instance['category'] = $new_instance['category'];
		$instance['num_post'] = $new_instance['num_post'];
		return $instance;
	}
} // class Foo_Widget
// register Foo_Widget widget
function register_foo_widget() {
    register_widget( 'Foo_Widget' );
}
add_action( 'widgets_init', 'register_foo_widget' );
?>